// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CONTENT_COMMON_SHARED_WORKER_SHARED_WORKER_FACTORY_MOJOM_SHARED_INTERNAL_H_
#define CONTENT_COMMON_SHARED_WORKER_SHARED_WORKER_FACTORY_MOJOM_SHARED_INTERNAL_H_

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "content/common/native_types.mojom-shared-internal.h"
#include "content/common/service_worker/service_worker_provider.mojom-shared-internal.h"
#include "content/common/shared_worker/shared_worker.mojom-shared-internal.h"
#include "content/common/shared_worker/shared_worker_host.mojom-shared-internal.h"
#include "content/common/shared_worker/shared_worker_info.mojom-shared-internal.h"
#include "content/common/url_loader_factory_bundle.mojom-shared-internal.h"
#include "mojo/public/mojom/base/unguessable_token.mojom-shared-internal.h"
#include "services/network/public/mojom/url_loader_factory.mojom-shared-internal.h"
#include "services/service_manager/public/mojom/interface_provider.mojom-shared-internal.h"
#include "third_party/blink/public/web/worker_content_settings_proxy.mojom-shared-internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/interfaces/bindings/native_struct.mojom-shared-internal.h"
#include "base/component_export.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace content {
namespace mojom {
namespace internal {

#pragma pack(push, 1)
class COMPONENT_EXPORT(MOJOM_SHARED_CONTENT_EXPORT) SharedWorkerFactory_CreateSharedWorker_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(SharedWorkerFactory_CreateSharedWorker_Params_Data));
      new (data()) SharedWorkerFactory_CreateSharedWorker_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    SharedWorkerFactory_CreateSharedWorker_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<SharedWorkerFactory_CreateSharedWorker_Params_Data>(index_);
    }
    SharedWorkerFactory_CreateSharedWorker_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::content::mojom::internal::SharedWorkerInfo_Data> info;
  uint8_t pause_on_start : 1;
  uint8_t pad1_[3];
  mojo::internal::Handle_Data shared_worker;
  mojo::internal::Pointer<::mojo_base::mojom::internal::UnguessableToken_Data> devtools_worker_token;
  mojo::internal::Pointer<::content::mojom::internal::RendererPreferences_Data> renderer_preferences;
  mojo::internal::Interface_Data content_settings;
  mojo::internal::Pointer<::content::mojom::internal::ServiceWorkerProviderInfoForSharedWorker_Data> service_worker_provider_info;
  mojo::internal::AssociatedInterface_Data script_loader_factory_ptr_info;
  mojo::internal::Pointer<::content::mojom::internal::URLLoaderFactoryBundle_Data> subresource_loader_factories;
  mojo::internal::Interface_Data host;
  mojo::internal::Interface_Data interface_provider;

 private:
  SharedWorkerFactory_CreateSharedWorker_Params_Data();
  ~SharedWorkerFactory_CreateSharedWorker_Params_Data() = delete;
};
static_assert(sizeof(SharedWorkerFactory_CreateSharedWorker_Params_Data) == 88,
              "Bad sizeof(SharedWorkerFactory_CreateSharedWorker_Params_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace content

#endif  // CONTENT_COMMON_SHARED_WORKER_SHARED_WORKER_FACTORY_MOJOM_SHARED_INTERNAL_H_