// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#elif defined(_MSC_VER)
#pragma warning(push)
#pragma warning(disable:4056)
#pragma warning(disable:4065)
#pragma warning(disable:4756)
#endif

#include "services/network/public/mojom/network_quality_estimator_manager.mojom-blink.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/logging.h"
#include "base/run_loop.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_context.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"

#include "services/network/public/mojom/network_quality_estimator_manager.mojom-shared-message-ids.h"
#include "mojo/public/cpp/bindings/lib/wtf_serialization.h"
#include "ipc/ipc_message_utils.h"
#include "mojo/public/cpp/base/time_mojom_traits.h"
namespace network {
namespace mojom {
namespace blink {
const char NetworkQualityEstimatorManagerClient::Name_[] = "network.mojom.NetworkQualityEstimatorManagerClient";

NetworkQualityEstimatorManagerClientProxy::NetworkQualityEstimatorManagerClientProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}
class NetworkQualityEstimatorManagerClientProxy_OnNetworkQualityChanged_Message
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  explicit NetworkQualityEstimatorManagerClientProxy_OnNetworkQualityChanged_Message(
      uint32_t message_flags
      , ::network::mojom::blink::EffectiveConnectionType param_type
      , WTF::TimeDelta param_http_rtt
      , WTF::TimeDelta param_transport_rtt
      , int32_t param_downlink_bandwidth_kbps
  )
      : mojo::internal::UnserializedMessageContext(
          &kMessageTag,
          internal::kNetworkQualityEstimatorManagerClient_OnNetworkQualityChanged_Name,
          message_flags)
      , param_type_(std::move(param_type))
      , param_http_rtt_(std::move(param_http_rtt))
      , param_transport_rtt_(std::move(param_transport_rtt))
      , param_downlink_bandwidth_kbps_(std::move(param_downlink_bandwidth_kbps)){}
  ~NetworkQualityEstimatorManagerClientProxy_OnNetworkQualityChanged_Message() override = default;

  static mojo::Message Build(
      bool serialize,
      bool expects_response,
      bool is_sync,
      ::network::mojom::blink::EffectiveConnectionType param_type, WTF::TimeDelta param_http_rtt, WTF::TimeDelta param_transport_rtt, int32_t param_downlink_bandwidth_kbps) {

    
  const uint32_t kFlags =
      ((expects_response) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((is_sync) ? mojo::Message::kFlagIsSync : 0);

    if (!serialize) {
      return mojo::Message(std::make_unique<NetworkQualityEstimatorManagerClientProxy_OnNetworkQualityChanged_Message>(
          kFlags
          , std::move(param_type)
          , std::move(param_http_rtt)
          , std::move(param_transport_rtt)
          , std::move(param_downlink_bandwidth_kbps)
          ));
    }

    DCHECK(serialize);
    
  mojo::Message message(
      internal::kNetworkQualityEstimatorManagerClient_OnNetworkQualityChanged_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::network::mojom::internal::NetworkQualityEstimatorManagerClient_OnNetworkQualityChanged_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  mojo::internal::Serialize<::network::mojom::EffectiveConnectionType>(
      param_type, &params->type);
  typename decltype(params->http_rtt)::BaseType::BufferWriter
      http_rtt_writer;
  mojo::internal::Serialize<::mojo_base::mojom::TimeDeltaDataView>(
      param_http_rtt, buffer, &http_rtt_writer, &serialization_context);
  params->http_rtt.Set(
      http_rtt_writer.is_null() ? nullptr : http_rtt_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->http_rtt.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null http_rtt in NetworkQualityEstimatorManagerClient.OnNetworkQualityChanged request");
  typename decltype(params->transport_rtt)::BaseType::BufferWriter
      transport_rtt_writer;
  mojo::internal::Serialize<::mojo_base::mojom::TimeDeltaDataView>(
      param_transport_rtt, buffer, &transport_rtt_writer, &serialization_context);
  params->transport_rtt.Set(
      transport_rtt_writer.is_null() ? nullptr : transport_rtt_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->transport_rtt.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null transport_rtt in NetworkQualityEstimatorManagerClient.OnNetworkQualityChanged request");
  params->downlink_bandwidth_kbps = param_downlink_bandwidth_kbps;
  message.AttachHandlesFromSerializationContext(
      &serialization_context);
    return message;
  }


  void Dispatch(NetworkQualityEstimatorManagerClient* impl) {
    impl->OnNetworkQualityChanged(
        std::move(param_type_),
        std::move(param_http_rtt_),
        std::move(param_transport_rtt_),
        std::move(param_downlink_bandwidth_kbps_));
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::internal::SerializationContext* serialization_context,
                 mojo::internal::Buffer* buffer) override {
    ::network::mojom::internal::NetworkQualityEstimatorManagerClient_OnNetworkQualityChanged_Params_Data::BufferWriter
        params;
    params.Allocate(buffer);
  mojo::internal::Serialize<::network::mojom::EffectiveConnectionType>(
      param_type_, &params->type);
  typename decltype(params->http_rtt)::BaseType::BufferWriter
      http_rtt_writer;
  mojo::internal::Serialize<::mojo_base::mojom::TimeDeltaDataView>(
      param_http_rtt_, buffer, &http_rtt_writer, serialization_context);
  params->http_rtt.Set(
      http_rtt_writer.is_null() ? nullptr : http_rtt_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->http_rtt.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null http_rtt in NetworkQualityEstimatorManagerClient.OnNetworkQualityChanged request");
  typename decltype(params->transport_rtt)::BaseType::BufferWriter
      transport_rtt_writer;
  mojo::internal::Serialize<::mojo_base::mojom::TimeDeltaDataView>(
      param_transport_rtt_, buffer, &transport_rtt_writer, serialization_context);
  params->transport_rtt.Set(
      transport_rtt_writer.is_null() ? nullptr : transport_rtt_writer.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->transport_rtt.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null transport_rtt in NetworkQualityEstimatorManagerClient.OnNetworkQualityChanged request");
  params->downlink_bandwidth_kbps = param_downlink_bandwidth_kbps_;
  }
  ::network::mojom::blink::EffectiveConnectionType param_type_;
  WTF::TimeDelta param_http_rtt_;
  WTF::TimeDelta param_transport_rtt_;
  int32_t param_downlink_bandwidth_kbps_;

  DISALLOW_COPY_AND_ASSIGN(NetworkQualityEstimatorManagerClientProxy_OnNetworkQualityChanged_Message);
};

const mojo::internal::UnserializedMessageContext::Tag
NetworkQualityEstimatorManagerClientProxy_OnNetworkQualityChanged_Message::kMessageTag = {};

void NetworkQualityEstimatorManagerClientProxy::OnNetworkQualityChanged(
    ::network::mojom::blink::EffectiveConnectionType in_type, WTF::TimeDelta in_http_rtt, WTF::TimeDelta in_transport_rtt, int32_t in_downlink_bandwidth_kbps) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "network::mojom::NetworkQualityEstimatorManagerClient::OnNetworkQualityChanged");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  const bool kSerialize = receiver_->PrefersSerializedMessages();
  auto message = NetworkQualityEstimatorManagerClientProxy_OnNetworkQualityChanged_Message::Build(
      kSerialize, kExpectsResponse, kIsSync, std::move(in_type), std::move(in_http_rtt), std::move(in_transport_rtt), std::move(in_downlink_bandwidth_kbps));

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(NetworkQualityEstimatorManagerClient::Name_);
  message.set_method_name("OnNetworkQualityChanged");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

// static
bool NetworkQualityEstimatorManagerClientStubDispatch::Accept(
    NetworkQualityEstimatorManagerClient* impl,
    mojo::Message* message) {
  switch (message->header()->name) {
    case internal::kNetworkQualityEstimatorManagerClient_OnNetworkQualityChanged_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)network::mojom::NetworkQualityEstimatorManagerClient::OnNetworkQualityChanged",
               "message", message->name());
#endif
      mojo::internal::MessageDispatchContext context(message);
      if (!message->is_serialized()) {
        auto context = message->TakeUnserializedContext<
            NetworkQualityEstimatorManagerClientProxy_OnNetworkQualityChanged_Message>();
        if (!context) {
          // The Message was not of the expected type. It may be a valid message
          // which was serialized using a different variant of these bindings.
          // Force serialization before dispatch in this case.
          message->SerializeIfNecessary();
        } else {
          context->Dispatch(impl);
          return true;
        }
      }

      DCHECK(message->is_serialized());
      internal::NetworkQualityEstimatorManagerClient_OnNetworkQualityChanged_Params_Data* params =
          reinterpret_cast<internal::NetworkQualityEstimatorManagerClient_OnNetworkQualityChanged_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      ::network::mojom::blink::EffectiveConnectionType p_type{};
      WTF::TimeDelta p_http_rtt{};
      WTF::TimeDelta p_transport_rtt{};
      int32_t p_downlink_bandwidth_kbps{};
      NetworkQualityEstimatorManagerClient_OnNetworkQualityChanged_ParamsDataView input_data_view(params, &serialization_context);
      
      if (!input_data_view.ReadType(&p_type))
        success = false;
      if (!input_data_view.ReadHttpRtt(&p_http_rtt))
        success = false;
      if (!input_data_view.ReadTransportRtt(&p_transport_rtt))
        success = false;
      p_downlink_bandwidth_kbps = input_data_view.downlink_bandwidth_kbps();
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "NetworkQualityEstimatorManagerClient::OnNetworkQualityChanged deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->OnNetworkQualityChanged(
std::move(p_type), 
std::move(p_http_rtt), 
std::move(p_transport_rtt), 
std::move(p_downlink_bandwidth_kbps));
      return true;
    }
  }
  return false;
}

// static
bool NetworkQualityEstimatorManagerClientStubDispatch::AcceptWithResponder(
    NetworkQualityEstimatorManagerClient* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  switch (message->header()->name) {
    case internal::kNetworkQualityEstimatorManagerClient_OnNetworkQualityChanged_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)network::mojom::NetworkQualityEstimatorManagerClient::OnNetworkQualityChanged",
               "message", message->name());
#endif
      break;
    }
  }
  return false;
}

bool NetworkQualityEstimatorManagerClientRequestValidator::Accept(mojo::Message* message) {
  if (!message->is_serialized() ||
      mojo::internal::ControlMessageHandler::IsControlMessage(message)) {
    return true;
  }

  mojo::internal::ValidationContext validation_context(
    message->payload(), message->payload_num_bytes(),
    message->handles()->size(), message->payload_num_interface_ids(), message,
    "NetworkQualityEstimatorManagerClient RequestValidator");

  switch (message->header()->name) {
    case internal::kNetworkQualityEstimatorManagerClient_OnNetworkQualityChanged_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::NetworkQualityEstimatorManagerClient_OnNetworkQualityChanged_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}

void NetworkQualityEstimatorManagerClientInterceptorForTesting::OnNetworkQualityChanged(::network::mojom::blink::EffectiveConnectionType type, WTF::TimeDelta http_rtt, WTF::TimeDelta transport_rtt, int32_t downlink_bandwidth_kbps) {
  GetForwardingInterface()->OnNetworkQualityChanged(std::move(type), std::move(http_rtt), std::move(transport_rtt), std::move(downlink_bandwidth_kbps));
}
NetworkQualityEstimatorManagerClientAsyncWaiter::NetworkQualityEstimatorManagerClientAsyncWaiter(
    NetworkQualityEstimatorManagerClient* proxy) : proxy_(proxy) {}

NetworkQualityEstimatorManagerClientAsyncWaiter::~NetworkQualityEstimatorManagerClientAsyncWaiter() = default;


const char NetworkQualityEstimatorManager::Name_[] = "network.mojom.NetworkQualityEstimatorManager";

NetworkQualityEstimatorManagerProxy::NetworkQualityEstimatorManagerProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}
class NetworkQualityEstimatorManagerProxy_RequestNotifications_Message
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  explicit NetworkQualityEstimatorManagerProxy_RequestNotifications_Message(
      uint32_t message_flags
      , NetworkQualityEstimatorManagerClientPtr param_client_ptr
  )
      : mojo::internal::UnserializedMessageContext(
          &kMessageTag,
          internal::kNetworkQualityEstimatorManager_RequestNotifications_Name,
          message_flags)
      , param_client_ptr_(param_client_ptr.PassInterface()){}
  ~NetworkQualityEstimatorManagerProxy_RequestNotifications_Message() override = default;

  static mojo::Message Build(
      bool serialize,
      bool expects_response,
      bool is_sync,
      NetworkQualityEstimatorManagerClientPtr param_client_ptr) {

    
  const uint32_t kFlags =
      ((expects_response) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((is_sync) ? mojo::Message::kFlagIsSync : 0);

    if (!serialize) {
      return mojo::Message(std::make_unique<NetworkQualityEstimatorManagerProxy_RequestNotifications_Message>(
          kFlags
          , std::move(param_client_ptr)
          ));
    }

    DCHECK(serialize);
    
  mojo::Message message(
      internal::kNetworkQualityEstimatorManager_RequestNotifications_Name, kFlags, 0, 0, nullptr);
  auto* buffer = message.payload_buffer();
  ::network::mojom::internal::NetworkQualityEstimatorManager_RequestNotifications_Params_Data::BufferWriter
      params;
  mojo::internal::SerializationContext serialization_context;
  params.Allocate(buffer);
  mojo::internal::Serialize<::network::mojom::NetworkQualityEstimatorManagerClientPtrDataView>(
      param_client_ptr, &params->client_ptr, &serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->client_ptr),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
      "invalid client_ptr in NetworkQualityEstimatorManager.RequestNotifications request");
  message.AttachHandlesFromSerializationContext(
      &serialization_context);
    return message;
  }


  void Dispatch(NetworkQualityEstimatorManager* impl) {
    impl->RequestNotifications(
        NetworkQualityEstimatorManagerClientPtr(std::move(param_client_ptr_)));
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::internal::SerializationContext* serialization_context,
                 mojo::internal::Buffer* buffer) override {
    ::network::mojom::internal::NetworkQualityEstimatorManager_RequestNotifications_Params_Data::BufferWriter
        params;
    params.Allocate(buffer);
  mojo::internal::Serialize<::network::mojom::NetworkQualityEstimatorManagerClientPtrDataView>(
      param_client_ptr_, &params->client_ptr, serialization_context);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->client_ptr),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
      "invalid client_ptr in NetworkQualityEstimatorManager.RequestNotifications request");
  }
  NetworkQualityEstimatorManagerClientPtrInfo param_client_ptr_;

  DISALLOW_COPY_AND_ASSIGN(NetworkQualityEstimatorManagerProxy_RequestNotifications_Message);
};

const mojo::internal::UnserializedMessageContext::Tag
NetworkQualityEstimatorManagerProxy_RequestNotifications_Message::kMessageTag = {};

void NetworkQualityEstimatorManagerProxy::RequestNotifications(
    NetworkQualityEstimatorManagerClientPtr in_client_ptr) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "network::mojom::NetworkQualityEstimatorManager::RequestNotifications");
#endif
  const bool kExpectsResponse = false;
  const bool kIsSync = false;
  const bool kSerialize = receiver_->PrefersSerializedMessages();
  auto message = NetworkQualityEstimatorManagerProxy_RequestNotifications_Message::Build(
      kSerialize, kExpectsResponse, kIsSync, std::move(in_client_ptr));

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(NetworkQualityEstimatorManager::Name_);
  message.set_method_name("RequestNotifications");
#endif
  // This return value may be ignored as false implies the Connector has
  // encountered an error, which will be visible through other means.
  ignore_result(receiver_->Accept(&message));
}

// static
bool NetworkQualityEstimatorManagerStubDispatch::Accept(
    NetworkQualityEstimatorManager* impl,
    mojo::Message* message) {
  switch (message->header()->name) {
    case internal::kNetworkQualityEstimatorManager_RequestNotifications_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)network::mojom::NetworkQualityEstimatorManager::RequestNotifications",
               "message", message->name());
#endif
      mojo::internal::MessageDispatchContext context(message);
      if (!message->is_serialized()) {
        auto context = message->TakeUnserializedContext<
            NetworkQualityEstimatorManagerProxy_RequestNotifications_Message>();
        if (!context) {
          // The Message was not of the expected type. It may be a valid message
          // which was serialized using a different variant of these bindings.
          // Force serialization before dispatch in this case.
          message->SerializeIfNecessary();
        } else {
          context->Dispatch(impl);
          return true;
        }
      }

      DCHECK(message->is_serialized());
      internal::NetworkQualityEstimatorManager_RequestNotifications_Params_Data* params =
          reinterpret_cast<internal::NetworkQualityEstimatorManager_RequestNotifications_Params_Data*>(
              message->mutable_payload());
      
      mojo::internal::SerializationContext serialization_context;
      serialization_context.TakeHandlesFromMessage(message);
      bool success = true;
      NetworkQualityEstimatorManagerClientPtr p_client_ptr{};
      NetworkQualityEstimatorManager_RequestNotifications_ParamsDataView input_data_view(params, &serialization_context);
      
      p_client_ptr =
          input_data_view.TakeClientPtr<decltype(p_client_ptr)>();
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            "NetworkQualityEstimatorManager::RequestNotifications deserializer");
        return false;
      }
      // A null |impl| means no implementation was bound.
      assert(impl);
      impl->RequestNotifications(
std::move(p_client_ptr));
      return true;
    }
  }
  return false;
}

// static
bool NetworkQualityEstimatorManagerStubDispatch::AcceptWithResponder(
    NetworkQualityEstimatorManager* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  switch (message->header()->name) {
    case internal::kNetworkQualityEstimatorManager_RequestNotifications_Name: {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1("mojom", "(Impl)network::mojom::NetworkQualityEstimatorManager::RequestNotifications",
               "message", message->name());
#endif
      break;
    }
  }
  return false;
}

bool NetworkQualityEstimatorManagerRequestValidator::Accept(mojo::Message* message) {
  if (!message->is_serialized() ||
      mojo::internal::ControlMessageHandler::IsControlMessage(message)) {
    return true;
  }

  mojo::internal::ValidationContext validation_context(
    message->payload(), message->payload_num_bytes(),
    message->handles()->size(), message->payload_num_interface_ids(), message,
    "NetworkQualityEstimatorManager RequestValidator");

  switch (message->header()->name) {
    case internal::kNetworkQualityEstimatorManager_RequestNotifications_Name: {
      if (!mojo::internal::ValidateMessageIsRequestWithoutResponse(
              message, &validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateMessagePayload<
               internal::NetworkQualityEstimatorManager_RequestNotifications_Params_Data>(
                  message, &validation_context)) {
        return false;
      }
      return true;
    }
    default:
      break;
  }

  // Unrecognized message.
  ReportValidationError(
      &validation_context,
      mojo::internal::VALIDATION_ERROR_MESSAGE_HEADER_UNKNOWN_METHOD);
  return false;
}

void NetworkQualityEstimatorManagerInterceptorForTesting::RequestNotifications(NetworkQualityEstimatorManagerClientPtr client_ptr) {
  GetForwardingInterface()->RequestNotifications(std::move(client_ptr));
}
NetworkQualityEstimatorManagerAsyncWaiter::NetworkQualityEstimatorManagerAsyncWaiter(
    NetworkQualityEstimatorManager* proxy) : proxy_(proxy) {}

NetworkQualityEstimatorManagerAsyncWaiter::~NetworkQualityEstimatorManagerAsyncWaiter() = default;


}  // namespace blink
}  // namespace mojom
}  // namespace network

namespace mojo {

}  // namespace mojo

#if defined(__clang__)
#pragma clang diagnostic pop
#elif defined(_MSC_VER)
#pragma warning(pop)
#endif