// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_NETWORK_PUBLIC_MOJOM_NETWORK_QUALITY_ESTIMATOR_MANAGER_MOJOM_SHARED_H_
#define SERVICES_NETWORK_PUBLIC_MOJOM_NETWORK_QUALITY_ESTIMATOR_MANAGER_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <ostream>
#include <type_traits>
#include <utility>

#include "base/compiler_specific.h"
#include "base/containers/flat_map.h"
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"
#include "services/network/public/mojom/network_quality_estimator_manager.mojom-shared-internal.h"
#include "mojo/public/mojom/base/time.mojom-shared.h"
#include "services/network/public/mojom/network_types.mojom-shared.h"

#include "mojo/public/cpp/bindings/lib/interface_serialization.h"


#include "mojo/public/cpp/bindings/native_enum.h"
#include "mojo/public/cpp/bindings/lib/native_struct_serialization.h"


namespace network {
namespace mojom {


}  // namespace mojom
}  // namespace network

namespace mojo {
namespace internal {

}  // namespace internal
}  // namespace mojo


namespace network {
namespace mojom {
// Interface base classes. They are used for type safety check.
class NetworkQualityEstimatorManagerClientInterfaceBase {};

using NetworkQualityEstimatorManagerClientPtrDataView =
    mojo::InterfacePtrDataView<NetworkQualityEstimatorManagerClientInterfaceBase>;
using NetworkQualityEstimatorManagerClientRequestDataView =
    mojo::InterfaceRequestDataView<NetworkQualityEstimatorManagerClientInterfaceBase>;
using NetworkQualityEstimatorManagerClientAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<NetworkQualityEstimatorManagerClientInterfaceBase>;
using NetworkQualityEstimatorManagerClientAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<NetworkQualityEstimatorManagerClientInterfaceBase>;
class NetworkQualityEstimatorManagerInterfaceBase {};

using NetworkQualityEstimatorManagerPtrDataView =
    mojo::InterfacePtrDataView<NetworkQualityEstimatorManagerInterfaceBase>;
using NetworkQualityEstimatorManagerRequestDataView =
    mojo::InterfaceRequestDataView<NetworkQualityEstimatorManagerInterfaceBase>;
using NetworkQualityEstimatorManagerAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<NetworkQualityEstimatorManagerInterfaceBase>;
using NetworkQualityEstimatorManagerAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<NetworkQualityEstimatorManagerInterfaceBase>;
class NetworkQualityEstimatorManagerClient_OnNetworkQualityChanged_ParamsDataView {
 public:
  NetworkQualityEstimatorManagerClient_OnNetworkQualityChanged_ParamsDataView() {}

  NetworkQualityEstimatorManagerClient_OnNetworkQualityChanged_ParamsDataView(
      internal::NetworkQualityEstimatorManagerClient_OnNetworkQualityChanged_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadType(UserType* output) const {
    auto data_value = data_->type;
    return mojo::internal::Deserialize<::network::mojom::EffectiveConnectionType>(
        data_value, output);
  }

  ::network::mojom::EffectiveConnectionType type() const {
    return static_cast<::network::mojom::EffectiveConnectionType>(data_->type);
  }
  inline void GetHttpRttDataView(
      ::mojo_base::mojom::TimeDeltaDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadHttpRtt(UserType* output) {
    auto* pointer = data_->http_rtt.Get();
    return mojo::internal::Deserialize<::mojo_base::mojom::TimeDeltaDataView>(
        pointer, output, context_);
  }
  inline void GetTransportRttDataView(
      ::mojo_base::mojom::TimeDeltaDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadTransportRtt(UserType* output) {
    auto* pointer = data_->transport_rtt.Get();
    return mojo::internal::Deserialize<::mojo_base::mojom::TimeDeltaDataView>(
        pointer, output, context_);
  }
  int32_t downlink_bandwidth_kbps() const {
    return data_->downlink_bandwidth_kbps;
  }
 private:
  internal::NetworkQualityEstimatorManagerClient_OnNetworkQualityChanged_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class NetworkQualityEstimatorManager_RequestNotifications_ParamsDataView {
 public:
  NetworkQualityEstimatorManager_RequestNotifications_ParamsDataView() {}

  NetworkQualityEstimatorManager_RequestNotifications_ParamsDataView(
      internal::NetworkQualityEstimatorManager_RequestNotifications_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  UserType TakeClientPtr() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::network::mojom::NetworkQualityEstimatorManagerClientPtrDataView>(
            &data_->client_ptr, &result, context_);
    DCHECK(ret);
    return result;
  }
 private:
  internal::NetworkQualityEstimatorManager_RequestNotifications_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};



}  // namespace mojom
}  // namespace network

namespace std {

}  // namespace std

namespace mojo {

}  // namespace mojo


namespace network {
namespace mojom {

inline void NetworkQualityEstimatorManagerClient_OnNetworkQualityChanged_ParamsDataView::GetHttpRttDataView(
    ::mojo_base::mojom::TimeDeltaDataView* output) {
  auto pointer = data_->http_rtt.Get();
  *output = ::mojo_base::mojom::TimeDeltaDataView(pointer, context_);
}
inline void NetworkQualityEstimatorManagerClient_OnNetworkQualityChanged_ParamsDataView::GetTransportRttDataView(
    ::mojo_base::mojom::TimeDeltaDataView* output) {
  auto pointer = data_->transport_rtt.Get();
  *output = ::mojo_base::mojom::TimeDeltaDataView(pointer, context_);
}





}  // namespace mojom
}  // namespace network

#endif  // SERVICES_NETWORK_PUBLIC_MOJOM_NETWORK_QUALITY_ESTIMATOR_MANAGER_MOJOM_SHARED_H_
