// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_NETWORK_PUBLIC_MOJOM_PROXY_RESOLVING_SOCKET_MOJOM_SHARED_INTERNAL_H_
#define SERVICES_NETWORK_PUBLIC_MOJOM_PROXY_RESOLVING_SOCKET_MOJOM_SHARED_INTERNAL_H_

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "net/interfaces/ip_endpoint.mojom-shared-internal.h"
#include "services/network/public/mojom/mutable_network_traffic_annotation_tag.mojom-shared-internal.h"
#include "url/mojom/url.mojom-shared-internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/interfaces/bindings/native_struct.mojom-shared-internal.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace network {
namespace mojom {
namespace internal {

#pragma pack(push, 1)
class  ProxyResolvingSocket_GetPeerAddress_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ProxyResolvingSocket_GetPeerAddress_Params_Data));
      new (data()) ProxyResolvingSocket_GetPeerAddress_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ProxyResolvingSocket_GetPeerAddress_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ProxyResolvingSocket_GetPeerAddress_Params_Data>(index_);
    }
    ProxyResolvingSocket_GetPeerAddress_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  ProxyResolvingSocket_GetPeerAddress_Params_Data();
  ~ProxyResolvingSocket_GetPeerAddress_Params_Data() = delete;
};
static_assert(sizeof(ProxyResolvingSocket_GetPeerAddress_Params_Data) == 8,
              "Bad sizeof(ProxyResolvingSocket_GetPeerAddress_Params_Data)");
class  ProxyResolvingSocket_GetPeerAddress_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ProxyResolvingSocket_GetPeerAddress_ResponseParams_Data));
      new (data()) ProxyResolvingSocket_GetPeerAddress_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ProxyResolvingSocket_GetPeerAddress_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ProxyResolvingSocket_GetPeerAddress_ResponseParams_Data>(index_);
    }
    ProxyResolvingSocket_GetPeerAddress_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t net_error;
  uint8_t pad0_[4];
  mojo::internal::Pointer<::net::interfaces::internal::IPEndPoint_Data> peer_addr;

 private:
  ProxyResolvingSocket_GetPeerAddress_ResponseParams_Data();
  ~ProxyResolvingSocket_GetPeerAddress_ResponseParams_Data() = delete;
};
static_assert(sizeof(ProxyResolvingSocket_GetPeerAddress_ResponseParams_Data) == 24,
              "Bad sizeof(ProxyResolvingSocket_GetPeerAddress_ResponseParams_Data)");
class  ProxyResolvingSocketFactory_CreateProxyResolvingSocket_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ProxyResolvingSocketFactory_CreateProxyResolvingSocket_Params_Data));
      new (data()) ProxyResolvingSocketFactory_CreateProxyResolvingSocket_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ProxyResolvingSocketFactory_CreateProxyResolvingSocket_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ProxyResolvingSocketFactory_CreateProxyResolvingSocket_Params_Data>(index_);
    }
    ProxyResolvingSocketFactory_CreateProxyResolvingSocket_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::url::mojom::internal::Url_Data> url;
  uint8_t use_tls : 1;
  uint8_t pad1_[3];
  mojo::internal::Handle_Data socket;
  mojo::internal::Pointer<::network::mojom::internal::MutableNetworkTrafficAnnotationTag_Data> traffic_annotation;

 private:
  ProxyResolvingSocketFactory_CreateProxyResolvingSocket_Params_Data();
  ~ProxyResolvingSocketFactory_CreateProxyResolvingSocket_Params_Data() = delete;
};
static_assert(sizeof(ProxyResolvingSocketFactory_CreateProxyResolvingSocket_Params_Data) == 32,
              "Bad sizeof(ProxyResolvingSocketFactory_CreateProxyResolvingSocket_Params_Data)");
class  ProxyResolvingSocketFactory_CreateProxyResolvingSocket_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(ProxyResolvingSocketFactory_CreateProxyResolvingSocket_ResponseParams_Data));
      new (data()) ProxyResolvingSocketFactory_CreateProxyResolvingSocket_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    ProxyResolvingSocketFactory_CreateProxyResolvingSocket_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<ProxyResolvingSocketFactory_CreateProxyResolvingSocket_ResponseParams_Data>(index_);
    }
    ProxyResolvingSocketFactory_CreateProxyResolvingSocket_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t result;
  mojo::internal::Handle_Data receive_stream;
  mojo::internal::Pointer<::net::interfaces::internal::IPEndPoint_Data> local_addr;
  mojo::internal::Handle_Data send_stream;
  uint8_t padfinal_[4];

 private:
  ProxyResolvingSocketFactory_CreateProxyResolvingSocket_ResponseParams_Data();
  ~ProxyResolvingSocketFactory_CreateProxyResolvingSocket_ResponseParams_Data() = delete;
};
static_assert(sizeof(ProxyResolvingSocketFactory_CreateProxyResolvingSocket_ResponseParams_Data) == 32,
              "Bad sizeof(ProxyResolvingSocketFactory_CreateProxyResolvingSocket_ResponseParams_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace network

#endif  // SERVICES_NETWORK_PUBLIC_MOJOM_PROXY_RESOLVING_SOCKET_MOJOM_SHARED_INTERNAL_H_