// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_NETWORK_PUBLIC_MOJOM_PROXY_RESOLVING_SOCKET_MOJOM_SHARED_H_
#define SERVICES_NETWORK_PUBLIC_MOJOM_PROXY_RESOLVING_SOCKET_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <ostream>
#include <type_traits>
#include <utility>

#include "base/compiler_specific.h"
#include "base/containers/flat_map.h"
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"
#include "services/network/public/mojom/proxy_resolving_socket.mojom-shared-internal.h"
#include "net/interfaces/ip_endpoint.mojom-shared.h"
#include "services/network/public/mojom/mutable_network_traffic_annotation_tag.mojom-shared.h"
#include "url/mojom/url.mojom-shared.h"

#include "mojo/public/cpp/bindings/lib/interface_serialization.h"


#include "mojo/public/cpp/bindings/native_enum.h"
#include "mojo/public/cpp/bindings/lib/native_struct_serialization.h"


namespace network {
namespace mojom {


}  // namespace mojom
}  // namespace network

namespace mojo {
namespace internal {

}  // namespace internal
}  // namespace mojo


namespace network {
namespace mojom {
// Interface base classes. They are used for type safety check.
class ProxyResolvingSocketInterfaceBase {};

using ProxyResolvingSocketPtrDataView =
    mojo::InterfacePtrDataView<ProxyResolvingSocketInterfaceBase>;
using ProxyResolvingSocketRequestDataView =
    mojo::InterfaceRequestDataView<ProxyResolvingSocketInterfaceBase>;
using ProxyResolvingSocketAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<ProxyResolvingSocketInterfaceBase>;
using ProxyResolvingSocketAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<ProxyResolvingSocketInterfaceBase>;
class ProxyResolvingSocketFactoryInterfaceBase {};

using ProxyResolvingSocketFactoryPtrDataView =
    mojo::InterfacePtrDataView<ProxyResolvingSocketFactoryInterfaceBase>;
using ProxyResolvingSocketFactoryRequestDataView =
    mojo::InterfaceRequestDataView<ProxyResolvingSocketFactoryInterfaceBase>;
using ProxyResolvingSocketFactoryAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<ProxyResolvingSocketFactoryInterfaceBase>;
using ProxyResolvingSocketFactoryAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<ProxyResolvingSocketFactoryInterfaceBase>;
class ProxyResolvingSocket_GetPeerAddress_ParamsDataView {
 public:
  ProxyResolvingSocket_GetPeerAddress_ParamsDataView() {}

  ProxyResolvingSocket_GetPeerAddress_ParamsDataView(
      internal::ProxyResolvingSocket_GetPeerAddress_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::ProxyResolvingSocket_GetPeerAddress_Params_Data* data_ = nullptr;
};

class ProxyResolvingSocket_GetPeerAddress_ResponseParamsDataView {
 public:
  ProxyResolvingSocket_GetPeerAddress_ResponseParamsDataView() {}

  ProxyResolvingSocket_GetPeerAddress_ResponseParamsDataView(
      internal::ProxyResolvingSocket_GetPeerAddress_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  int32_t net_error() const {
    return data_->net_error;
  }
  inline void GetPeerAddrDataView(
      ::net::interfaces::IPEndPointDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadPeerAddr(UserType* output) {
    auto* pointer = data_->peer_addr.Get();
    return mojo::internal::Deserialize<::net::interfaces::IPEndPointDataView>(
        pointer, output, context_);
  }
 private:
  internal::ProxyResolvingSocket_GetPeerAddress_ResponseParams_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class ProxyResolvingSocketFactory_CreateProxyResolvingSocket_ParamsDataView {
 public:
  ProxyResolvingSocketFactory_CreateProxyResolvingSocket_ParamsDataView() {}

  ProxyResolvingSocketFactory_CreateProxyResolvingSocket_ParamsDataView(
      internal::ProxyResolvingSocketFactory_CreateProxyResolvingSocket_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetUrlDataView(
      ::url::mojom::UrlDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadUrl(UserType* output) {
    auto* pointer = data_->url.Get();
    return mojo::internal::Deserialize<::url::mojom::UrlDataView>(
        pointer, output, context_);
  }
  bool use_tls() const {
    return data_->use_tls;
  }
  inline void GetTrafficAnnotationDataView(
      ::network::mojom::MutableNetworkTrafficAnnotationTagDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadTrafficAnnotation(UserType* output) {
    auto* pointer = data_->traffic_annotation.Get();
    return mojo::internal::Deserialize<::network::mojom::MutableNetworkTrafficAnnotationTagDataView>(
        pointer, output, context_);
  }
  template <typename UserType>
  UserType TakeSocket() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::network::mojom::ProxyResolvingSocketRequestDataView>(
            &data_->socket, &result, context_);
    DCHECK(ret);
    return result;
  }
 private:
  internal::ProxyResolvingSocketFactory_CreateProxyResolvingSocket_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class ProxyResolvingSocketFactory_CreateProxyResolvingSocket_ResponseParamsDataView {
 public:
  ProxyResolvingSocketFactory_CreateProxyResolvingSocket_ResponseParamsDataView() {}

  ProxyResolvingSocketFactory_CreateProxyResolvingSocket_ResponseParamsDataView(
      internal::ProxyResolvingSocketFactory_CreateProxyResolvingSocket_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  int32_t result() const {
    return data_->result;
  }
  inline void GetLocalAddrDataView(
      ::net::interfaces::IPEndPointDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadLocalAddr(UserType* output) {
    auto* pointer = data_->local_addr.Get();
    return mojo::internal::Deserialize<::net::interfaces::IPEndPointDataView>(
        pointer, output, context_);
  }
  mojo::ScopedDataPipeConsumerHandle TakeReceiveStream() {
    mojo::ScopedDataPipeConsumerHandle result;
    bool ret =
        mojo::internal::Deserialize<mojo::ScopedDataPipeConsumerHandle>(
            &data_->receive_stream, &result, context_);
    DCHECK(ret);
    return result;
  }
  mojo::ScopedDataPipeProducerHandle TakeSendStream() {
    mojo::ScopedDataPipeProducerHandle result;
    bool ret =
        mojo::internal::Deserialize<mojo::ScopedDataPipeProducerHandle>(
            &data_->send_stream, &result, context_);
    DCHECK(ret);
    return result;
  }
 private:
  internal::ProxyResolvingSocketFactory_CreateProxyResolvingSocket_ResponseParams_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};



}  // namespace mojom
}  // namespace network

namespace std {

}  // namespace std

namespace mojo {

}  // namespace mojo


namespace network {
namespace mojom {



inline void ProxyResolvingSocket_GetPeerAddress_ResponseParamsDataView::GetPeerAddrDataView(
    ::net::interfaces::IPEndPointDataView* output) {
  auto pointer = data_->peer_addr.Get();
  *output = ::net::interfaces::IPEndPointDataView(pointer, context_);
}


inline void ProxyResolvingSocketFactory_CreateProxyResolvingSocket_ParamsDataView::GetUrlDataView(
    ::url::mojom::UrlDataView* output) {
  auto pointer = data_->url.Get();
  *output = ::url::mojom::UrlDataView(pointer, context_);
}
inline void ProxyResolvingSocketFactory_CreateProxyResolvingSocket_ParamsDataView::GetTrafficAnnotationDataView(
    ::network::mojom::MutableNetworkTrafficAnnotationTagDataView* output) {
  auto pointer = data_->traffic_annotation.Get();
  *output = ::network::mojom::MutableNetworkTrafficAnnotationTagDataView(pointer, context_);
}


inline void ProxyResolvingSocketFactory_CreateProxyResolvingSocket_ResponseParamsDataView::GetLocalAddrDataView(
    ::net::interfaces::IPEndPointDataView* output) {
  auto pointer = data_->local_addr.Get();
  *output = ::net::interfaces::IPEndPointDataView(pointer, context_);
}



}  // namespace mojom
}  // namespace network

#endif  // SERVICES_NETWORK_PUBLIC_MOJOM_PROXY_RESOLVING_SOCKET_MOJOM_SHARED_H_
