// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_RESOURCE_COORDINATOR_PUBLIC_MOJOM_PAGE_SIGNAL_MOJOM_SHARED_H_
#define SERVICES_RESOURCE_COORDINATOR_PUBLIC_MOJOM_PAGE_SIGNAL_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <ostream>
#include <type_traits>
#include <utility>

#include "base/compiler_specific.h"
#include "base/containers/flat_map.h"
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"
#include "services/resource_coordinator/public/mojom/page_signal.mojom-shared-internal.h"
#include "services/resource_coordinator/public/mojom/coordination_unit.mojom-shared.h"
#include "services/resource_coordinator/public/mojom/lifecycle.mojom-shared.h"
#include "mojo/public/mojom/base/time.mojom-shared.h"

#include "mojo/public/cpp/bindings/lib/interface_serialization.h"


#include "mojo/public/cpp/bindings/native_enum.h"
#include "mojo/public/cpp/bindings/lib/native_struct_serialization.h"
#include "base/component_export.h"


namespace resource_coordinator {
namespace mojom {
class PageNavigationIdentityDataView;



}  // namespace mojom
}  // namespace resource_coordinator

namespace mojo {
namespace internal {

template <>
struct MojomTypeTraits<::resource_coordinator::mojom::PageNavigationIdentityDataView> {
  using Data = ::resource_coordinator::mojom::internal::PageNavigationIdentity_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::STRUCT;
};

}  // namespace internal
}  // namespace mojo


namespace resource_coordinator {
namespace mojom {
// Interface base classes. They are used for type safety check.
class PageSignalReceiverInterfaceBase {};

using PageSignalReceiverPtrDataView =
    mojo::InterfacePtrDataView<PageSignalReceiverInterfaceBase>;
using PageSignalReceiverRequestDataView =
    mojo::InterfaceRequestDataView<PageSignalReceiverInterfaceBase>;
using PageSignalReceiverAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<PageSignalReceiverInterfaceBase>;
using PageSignalReceiverAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<PageSignalReceiverInterfaceBase>;
class PageSignalGeneratorInterfaceBase {};

using PageSignalGeneratorPtrDataView =
    mojo::InterfacePtrDataView<PageSignalGeneratorInterfaceBase>;
using PageSignalGeneratorRequestDataView =
    mojo::InterfaceRequestDataView<PageSignalGeneratorInterfaceBase>;
using PageSignalGeneratorAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<PageSignalGeneratorInterfaceBase>;
using PageSignalGeneratorAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<PageSignalGeneratorInterfaceBase>;
class PageNavigationIdentityDataView {
 public:
  PageNavigationIdentityDataView() {}

  PageNavigationIdentityDataView(
      internal::PageNavigationIdentity_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetPageCuIdDataView(
      ::resource_coordinator::mojom::CoordinationUnitIDDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadPageCuId(UserType* output) {
    auto* pointer = data_->page_cu_id.Get();
    return mojo::internal::Deserialize<::resource_coordinator::mojom::CoordinationUnitIDDataView>(
        pointer, output, context_);
  }
  int64_t navigation_id() const {
    return data_->navigation_id;
  }
  inline void GetUrlDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadUrl(UserType* output) {
    auto* pointer = data_->url.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, context_);
  }
 private:
  internal::PageNavigationIdentity_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class PageSignalReceiver_NotifyPageAlmostIdle_ParamsDataView {
 public:
  PageSignalReceiver_NotifyPageAlmostIdle_ParamsDataView() {}

  PageSignalReceiver_NotifyPageAlmostIdle_ParamsDataView(
      internal::PageSignalReceiver_NotifyPageAlmostIdle_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetPageNavigationIdDataView(
      PageNavigationIdentityDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadPageNavigationId(UserType* output) {
    auto* pointer = data_->page_navigation_id.Get();
    return mojo::internal::Deserialize<::resource_coordinator::mojom::PageNavigationIdentityDataView>(
        pointer, output, context_);
  }
 private:
  internal::PageSignalReceiver_NotifyPageAlmostIdle_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class PageSignalReceiver_NotifyRendererIsBloated_ParamsDataView {
 public:
  PageSignalReceiver_NotifyRendererIsBloated_ParamsDataView() {}

  PageSignalReceiver_NotifyRendererIsBloated_ParamsDataView(
      internal::PageSignalReceiver_NotifyRendererIsBloated_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetPageNavigationIdDataView(
      PageNavigationIdentityDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadPageNavigationId(UserType* output) {
    auto* pointer = data_->page_navigation_id.Get();
    return mojo::internal::Deserialize<::resource_coordinator::mojom::PageNavigationIdentityDataView>(
        pointer, output, context_);
  }
 private:
  internal::PageSignalReceiver_NotifyRendererIsBloated_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class PageSignalReceiver_SetExpectedTaskQueueingDuration_ParamsDataView {
 public:
  PageSignalReceiver_SetExpectedTaskQueueingDuration_ParamsDataView() {}

  PageSignalReceiver_SetExpectedTaskQueueingDuration_ParamsDataView(
      internal::PageSignalReceiver_SetExpectedTaskQueueingDuration_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetPageNavigationIdDataView(
      PageNavigationIdentityDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadPageNavigationId(UserType* output) {
    auto* pointer = data_->page_navigation_id.Get();
    return mojo::internal::Deserialize<::resource_coordinator::mojom::PageNavigationIdentityDataView>(
        pointer, output, context_);
  }
  inline void GetDurationDataView(
      ::mojo_base::mojom::TimeDeltaDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadDuration(UserType* output) {
    auto* pointer = data_->duration.Get();
    return mojo::internal::Deserialize<::mojo_base::mojom::TimeDeltaDataView>(
        pointer, output, context_);
  }
 private:
  internal::PageSignalReceiver_SetExpectedTaskQueueingDuration_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class PageSignalReceiver_SetLifecycleState_ParamsDataView {
 public:
  PageSignalReceiver_SetLifecycleState_ParamsDataView() {}

  PageSignalReceiver_SetLifecycleState_ParamsDataView(
      internal::PageSignalReceiver_SetLifecycleState_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetPageNavigationIdDataView(
      PageNavigationIdentityDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadPageNavigationId(UserType* output) {
    auto* pointer = data_->page_navigation_id.Get();
    return mojo::internal::Deserialize<::resource_coordinator::mojom::PageNavigationIdentityDataView>(
        pointer, output, context_);
  }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadState(UserType* output) const {
    auto data_value = data_->state;
    return mojo::internal::Deserialize<::resource_coordinator::mojom::LifecycleState>(
        data_value, output);
  }

  ::resource_coordinator::mojom::LifecycleState state() const {
    return static_cast<::resource_coordinator::mojom::LifecycleState>(data_->state);
  }
 private:
  internal::PageSignalReceiver_SetLifecycleState_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class PageSignalReceiver_NotifyNonPersistentNotificationCreated_ParamsDataView {
 public:
  PageSignalReceiver_NotifyNonPersistentNotificationCreated_ParamsDataView() {}

  PageSignalReceiver_NotifyNonPersistentNotificationCreated_ParamsDataView(
      internal::PageSignalReceiver_NotifyNonPersistentNotificationCreated_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetPageNavigationIdDataView(
      PageNavigationIdentityDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadPageNavigationId(UserType* output) {
    auto* pointer = data_->page_navigation_id.Get();
    return mojo::internal::Deserialize<::resource_coordinator::mojom::PageNavigationIdentityDataView>(
        pointer, output, context_);
  }
 private:
  internal::PageSignalReceiver_NotifyNonPersistentNotificationCreated_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class PageSignalReceiver_OnLoadTimePerformanceEstimate_ParamsDataView {
 public:
  PageSignalReceiver_OnLoadTimePerformanceEstimate_ParamsDataView() {}

  PageSignalReceiver_OnLoadTimePerformanceEstimate_ParamsDataView(
      internal::PageSignalReceiver_OnLoadTimePerformanceEstimate_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetPageNavigationIdDataView(
      PageNavigationIdentityDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadPageNavigationId(UserType* output) {
    auto* pointer = data_->page_navigation_id.Get();
    return mojo::internal::Deserialize<::resource_coordinator::mojom::PageNavigationIdentityDataView>(
        pointer, output, context_);
  }
  inline void GetCpuUsageEstimateDataView(
      ::mojo_base::mojom::TimeDeltaDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadCpuUsageEstimate(UserType* output) {
    auto* pointer = data_->cpu_usage_estimate.Get();
    return mojo::internal::Deserialize<::mojo_base::mojom::TimeDeltaDataView>(
        pointer, output, context_);
  }
  uint64_t private_footprint_kb_estimate() const {
    return data_->private_footprint_kb_estimate;
  }
 private:
  internal::PageSignalReceiver_OnLoadTimePerformanceEstimate_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class PageSignalGenerator_AddReceiver_ParamsDataView {
 public:
  PageSignalGenerator_AddReceiver_ParamsDataView() {}

  PageSignalGenerator_AddReceiver_ParamsDataView(
      internal::PageSignalGenerator_AddReceiver_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  UserType TakeReceiver() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::resource_coordinator::mojom::PageSignalReceiverPtrDataView>(
            &data_->receiver, &result, context_);
    DCHECK(ret);
    return result;
  }
 private:
  internal::PageSignalGenerator_AddReceiver_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};



}  // namespace mojom
}  // namespace resource_coordinator

namespace std {

}  // namespace std

namespace mojo {


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::resource_coordinator::mojom::PageNavigationIdentityDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::resource_coordinator::mojom::PageNavigationIdentityDataView, UserType>;

  static void Serialize(MaybeConstUserType& input,
                        Buffer* buffer,
                        ::resource_coordinator::mojom::internal::PageNavigationIdentity_Data::BufferWriter* output,
                        SerializationContext* context) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    void* custom_context = CustomContextHelper<Traits>::SetUp(input, context);
    (*output).Allocate(buffer);
    decltype(CallWithContext(Traits::page_cu_id, input, custom_context)) in_page_cu_id = CallWithContext(Traits::page_cu_id, input, custom_context);
    typename decltype((*output)->page_cu_id)::BaseType::BufferWriter
        page_cu_id_writer;
    mojo::internal::Serialize<::resource_coordinator::mojom::CoordinationUnitIDDataView>(
        in_page_cu_id, buffer, &page_cu_id_writer, context);
    (*output)->page_cu_id.Set(
        page_cu_id_writer.is_null() ? nullptr : page_cu_id_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->page_cu_id.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null page_cu_id in PageNavigationIdentity struct");
    (*output)->navigation_id = CallWithContext(Traits::navigation_id, input, custom_context);
    decltype(CallWithContext(Traits::url, input, custom_context)) in_url = CallWithContext(Traits::url, input, custom_context);
    typename decltype((*output)->url)::BaseType::BufferWriter
        url_writer;
    mojo::internal::Serialize<mojo::StringDataView>(
        in_url, buffer, &url_writer, context);
    (*output)->url.Set(
        url_writer.is_null() ? nullptr : url_writer.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        (*output)->url.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null url in PageNavigationIdentity struct");
    CustomContextHelper<Traits>::TearDown(input, custom_context);
  }

  static bool Deserialize(::resource_coordinator::mojom::internal::PageNavigationIdentity_Data* input,
                          UserType* output,
                          SerializationContext* context) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::resource_coordinator::mojom::PageNavigationIdentityDataView data_view(input, context);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal

}  // namespace mojo


namespace resource_coordinator {
namespace mojom {

inline void PageNavigationIdentityDataView::GetPageCuIdDataView(
    ::resource_coordinator::mojom::CoordinationUnitIDDataView* output) {
  auto pointer = data_->page_cu_id.Get();
  *output = ::resource_coordinator::mojom::CoordinationUnitIDDataView(pointer, context_);
}
inline void PageNavigationIdentityDataView::GetUrlDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->url.Get();
  *output = mojo::StringDataView(pointer, context_);
}


inline void PageSignalReceiver_NotifyPageAlmostIdle_ParamsDataView::GetPageNavigationIdDataView(
    PageNavigationIdentityDataView* output) {
  auto pointer = data_->page_navigation_id.Get();
  *output = PageNavigationIdentityDataView(pointer, context_);
}


inline void PageSignalReceiver_NotifyRendererIsBloated_ParamsDataView::GetPageNavigationIdDataView(
    PageNavigationIdentityDataView* output) {
  auto pointer = data_->page_navigation_id.Get();
  *output = PageNavigationIdentityDataView(pointer, context_);
}


inline void PageSignalReceiver_SetExpectedTaskQueueingDuration_ParamsDataView::GetPageNavigationIdDataView(
    PageNavigationIdentityDataView* output) {
  auto pointer = data_->page_navigation_id.Get();
  *output = PageNavigationIdentityDataView(pointer, context_);
}
inline void PageSignalReceiver_SetExpectedTaskQueueingDuration_ParamsDataView::GetDurationDataView(
    ::mojo_base::mojom::TimeDeltaDataView* output) {
  auto pointer = data_->duration.Get();
  *output = ::mojo_base::mojom::TimeDeltaDataView(pointer, context_);
}


inline void PageSignalReceiver_SetLifecycleState_ParamsDataView::GetPageNavigationIdDataView(
    PageNavigationIdentityDataView* output) {
  auto pointer = data_->page_navigation_id.Get();
  *output = PageNavigationIdentityDataView(pointer, context_);
}


inline void PageSignalReceiver_NotifyNonPersistentNotificationCreated_ParamsDataView::GetPageNavigationIdDataView(
    PageNavigationIdentityDataView* output) {
  auto pointer = data_->page_navigation_id.Get();
  *output = PageNavigationIdentityDataView(pointer, context_);
}


inline void PageSignalReceiver_OnLoadTimePerformanceEstimate_ParamsDataView::GetPageNavigationIdDataView(
    PageNavigationIdentityDataView* output) {
  auto pointer = data_->page_navigation_id.Get();
  *output = PageNavigationIdentityDataView(pointer, context_);
}
inline void PageSignalReceiver_OnLoadTimePerformanceEstimate_ParamsDataView::GetCpuUsageEstimateDataView(
    ::mojo_base::mojom::TimeDeltaDataView* output) {
  auto pointer = data_->cpu_usage_estimate.Get();
  *output = ::mojo_base::mojom::TimeDeltaDataView(pointer, context_);
}





}  // namespace mojom
}  // namespace resource_coordinator

#endif  // SERVICES_RESOURCE_COORDINATOR_PUBLIC_MOJOM_PAGE_SIGNAL_MOJOM_SHARED_H_
