// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_SHAPE_DETECTION_PUBLIC_MOJOM_BARCODEDETECTION_PROVIDER_MOJOM_SHARED_INTERNAL_H_
#define SERVICES_SHAPE_DETECTION_PUBLIC_MOJOM_BARCODEDETECTION_PROVIDER_MOJOM_SHARED_INTERNAL_H_

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "services/shape_detection/public/mojom/barcodedetection.mojom-shared-internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/interfaces/bindings/native_struct.mojom-shared-internal.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace shape_detection {
namespace mojom {
namespace internal {
class BarcodeDetectorOptions_Data;

struct BarcodeFormat_Data {
 public:
  static bool constexpr kIsExtensible = false;

  static bool IsKnownValue(int32_t value) {
    switch (value) {
      case 0:
      case 1:
      case 2:
      case 3:
      case 4:
      case 5:
      case 6:
      case 7:
      case 8:
      case 9:
      case 10:
      case 11:
      case 12:
      case 13:
        return true;
    }
    return false;
  }

  static bool Validate(int32_t value,
                       mojo::internal::ValidationContext* validation_context) {
    if (kIsExtensible || IsKnownValue(value))
      return true;

    ReportValidationError(validation_context,
                          mojo::internal::VALIDATION_ERROR_UNKNOWN_ENUM_VALUE);
    return false;
  }
};

#pragma pack(push, 1)
class  BarcodeDetectorOptions_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(BarcodeDetectorOptions_Data));
      new (data()) BarcodeDetectorOptions_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    BarcodeDetectorOptions_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<BarcodeDetectorOptions_Data>(index_);
    }
    BarcodeDetectorOptions_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Array_Data<int32_t>> formats;

 private:
  BarcodeDetectorOptions_Data();
  ~BarcodeDetectorOptions_Data() = delete;
};
static_assert(sizeof(BarcodeDetectorOptions_Data) == 16,
              "Bad sizeof(BarcodeDetectorOptions_Data)");
// Used by BarcodeDetectorOptions::WrapAsMessage to lazily serialize the struct.
template <typename UserType, typename DataView>
struct BarcodeDetectorOptions_UnserializedMessageContext
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  BarcodeDetectorOptions_UnserializedMessageContext(
    uint32_t message_name,
    uint32_t message_flags,
    UserType input)
      : mojo::internal::UnserializedMessageContext(&kMessageTag, message_name, message_flags)
      , user_data_(std::move(input)) {}
  ~BarcodeDetectorOptions_UnserializedMessageContext() override = default;

  UserType TakeData() {
    return std::move(user_data_);
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::internal::SerializationContext* context,
                 mojo::internal::Buffer* buffer) override {
    BarcodeDetectorOptions_Data::BufferWriter writer;
    mojo::internal::Serialize<DataView>(user_data_, buffer, &writer, context);
  }

  UserType user_data_;
};

template <typename UserType, typename DataView>
const mojo::internal::UnserializedMessageContext::Tag
    BarcodeDetectorOptions_UnserializedMessageContext<UserType, DataView>::kMessageTag = {};
class  BarcodeDetectionProvider_CreateBarcodeDetection_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(BarcodeDetectionProvider_CreateBarcodeDetection_Params_Data));
      new (data()) BarcodeDetectionProvider_CreateBarcodeDetection_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    BarcodeDetectionProvider_CreateBarcodeDetection_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<BarcodeDetectionProvider_CreateBarcodeDetection_Params_Data>(index_);
    }
    BarcodeDetectionProvider_CreateBarcodeDetection_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Handle_Data request;
  uint8_t pad0_[4];
  mojo::internal::Pointer<internal::BarcodeDetectorOptions_Data> options;

 private:
  BarcodeDetectionProvider_CreateBarcodeDetection_Params_Data();
  ~BarcodeDetectionProvider_CreateBarcodeDetection_Params_Data() = delete;
};
static_assert(sizeof(BarcodeDetectionProvider_CreateBarcodeDetection_Params_Data) == 24,
              "Bad sizeof(BarcodeDetectionProvider_CreateBarcodeDetection_Params_Data)");
class  BarcodeDetectionProvider_EnumerateSupportedFormats_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(BarcodeDetectionProvider_EnumerateSupportedFormats_Params_Data));
      new (data()) BarcodeDetectionProvider_EnumerateSupportedFormats_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    BarcodeDetectionProvider_EnumerateSupportedFormats_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<BarcodeDetectionProvider_EnumerateSupportedFormats_Params_Data>(index_);
    }
    BarcodeDetectionProvider_EnumerateSupportedFormats_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  BarcodeDetectionProvider_EnumerateSupportedFormats_Params_Data();
  ~BarcodeDetectionProvider_EnumerateSupportedFormats_Params_Data() = delete;
};
static_assert(sizeof(BarcodeDetectionProvider_EnumerateSupportedFormats_Params_Data) == 8,
              "Bad sizeof(BarcodeDetectionProvider_EnumerateSupportedFormats_Params_Data)");
class  BarcodeDetectionProvider_EnumerateSupportedFormats_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(BarcodeDetectionProvider_EnumerateSupportedFormats_ResponseParams_Data));
      new (data()) BarcodeDetectionProvider_EnumerateSupportedFormats_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    BarcodeDetectionProvider_EnumerateSupportedFormats_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<BarcodeDetectionProvider_EnumerateSupportedFormats_ResponseParams_Data>(index_);
    }
    BarcodeDetectionProvider_EnumerateSupportedFormats_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Array_Data<int32_t>> supported_formats;

 private:
  BarcodeDetectionProvider_EnumerateSupportedFormats_ResponseParams_Data();
  ~BarcodeDetectionProvider_EnumerateSupportedFormats_ResponseParams_Data() = delete;
};
static_assert(sizeof(BarcodeDetectionProvider_EnumerateSupportedFormats_ResponseParams_Data) == 16,
              "Bad sizeof(BarcodeDetectionProvider_EnumerateSupportedFormats_ResponseParams_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace shape_detection

#endif  // SERVICES_SHAPE_DETECTION_PUBLIC_MOJOM_BARCODEDETECTION_PROVIDER_MOJOM_SHARED_INTERNAL_H_