// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_UI_PUBLIC_INTERFACES_REMOTING_EVENT_INJECTOR_MOJOM_SHARED_INTERNAL_H_
#define SERVICES_UI_PUBLIC_INTERFACES_REMOTING_EVENT_INJECTOR_MOJOM_SHARED_INTERNAL_H_

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "ui/gfx/geometry/mojo/geometry.mojom-shared-internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/interfaces/bindings/native_struct.mojom-shared-internal.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace ui {
namespace mojom {
namespace internal {

struct InjectedMouseButtonType_Data {
 public:
  static bool constexpr kIsExtensible = false;

  static bool IsKnownValue(int32_t value) {
    switch (value) {
      case 0:
      case 1:
      case 2:
        return true;
    }
    return false;
  }

  static bool Validate(int32_t value,
                       mojo::internal::ValidationContext* validation_context) {
    if (kIsExtensible || IsKnownValue(value))
      return true;

    ReportValidationError(validation_context,
                          mojo::internal::VALIDATION_ERROR_UNKNOWN_ENUM_VALUE);
    return false;
  }
};

#pragma pack(push, 1)
class  RemotingEventInjector_MoveCursorToLocationInPixels_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(RemotingEventInjector_MoveCursorToLocationInPixels_Params_Data));
      new (data()) RemotingEventInjector_MoveCursorToLocationInPixels_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    RemotingEventInjector_MoveCursorToLocationInPixels_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<RemotingEventInjector_MoveCursorToLocationInPixels_Params_Data>(index_);
    }
    RemotingEventInjector_MoveCursorToLocationInPixels_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::gfx::mojom::internal::PointF_Data> location;

 private:
  RemotingEventInjector_MoveCursorToLocationInPixels_Params_Data();
  ~RemotingEventInjector_MoveCursorToLocationInPixels_Params_Data() = delete;
};
static_assert(sizeof(RemotingEventInjector_MoveCursorToLocationInPixels_Params_Data) == 16,
              "Bad sizeof(RemotingEventInjector_MoveCursorToLocationInPixels_Params_Data)");
class  RemotingEventInjector_InjectMousePressOrRelease_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(RemotingEventInjector_InjectMousePressOrRelease_Params_Data));
      new (data()) RemotingEventInjector_InjectMousePressOrRelease_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    RemotingEventInjector_InjectMousePressOrRelease_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<RemotingEventInjector_InjectMousePressOrRelease_Params_Data>(index_);
    }
    RemotingEventInjector_InjectMousePressOrRelease_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t button;
  uint8_t down : 1;
  uint8_t padfinal_[3];

 private:
  RemotingEventInjector_InjectMousePressOrRelease_Params_Data();
  ~RemotingEventInjector_InjectMousePressOrRelease_Params_Data() = delete;
};
static_assert(sizeof(RemotingEventInjector_InjectMousePressOrRelease_Params_Data) == 16,
              "Bad sizeof(RemotingEventInjector_InjectMousePressOrRelease_Params_Data)");
class  RemotingEventInjector_InjectMouseWheelInPixels_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(RemotingEventInjector_InjectMouseWheelInPixels_Params_Data));
      new (data()) RemotingEventInjector_InjectMouseWheelInPixels_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    RemotingEventInjector_InjectMouseWheelInPixels_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<RemotingEventInjector_InjectMouseWheelInPixels_Params_Data>(index_);
    }
    RemotingEventInjector_InjectMouseWheelInPixels_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t delta_x;
  int32_t delta_y;

 private:
  RemotingEventInjector_InjectMouseWheelInPixels_Params_Data();
  ~RemotingEventInjector_InjectMouseWheelInPixels_Params_Data() = delete;
};
static_assert(sizeof(RemotingEventInjector_InjectMouseWheelInPixels_Params_Data) == 16,
              "Bad sizeof(RemotingEventInjector_InjectMouseWheelInPixels_Params_Data)");
class  RemotingEventInjector_InjectKeyEvent_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(RemotingEventInjector_InjectKeyEvent_Params_Data));
      new (data()) RemotingEventInjector_InjectKeyEvent_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    RemotingEventInjector_InjectKeyEvent_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<RemotingEventInjector_InjectKeyEvent_Params_Data>(index_);
    }
    RemotingEventInjector_InjectKeyEvent_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t native_key_code;
  uint8_t down : 1;
  uint8_t suppress_auto_repeat : 1;
  uint8_t padfinal_[3];

 private:
  RemotingEventInjector_InjectKeyEvent_Params_Data();
  ~RemotingEventInjector_InjectKeyEvent_Params_Data() = delete;
};
static_assert(sizeof(RemotingEventInjector_InjectKeyEvent_Params_Data) == 16,
              "Bad sizeof(RemotingEventInjector_InjectKeyEvent_Params_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace ui

#endif  // SERVICES_UI_PUBLIC_INTERFACES_REMOTING_EVENT_INJECTOR_MOJOM_SHARED_INTERNAL_H_