// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_DOM_STORAGE_STORAGE_AREA_MOJOM_SHARED_INTERNAL_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_DOM_STORAGE_STORAGE_AREA_MOJOM_SHARED_INTERNAL_H_

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/interfaces/bindings/native_struct.mojom-shared-internal.h"
#include "base/component_export.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace blink {
namespace mojom {
namespace internal {
class KeyValue_Data;

#pragma pack(push, 1)
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) KeyValue_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(KeyValue_Data));
      new (data()) KeyValue_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    KeyValue_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<KeyValue_Data>(index_);
    }
    KeyValue_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Array_Data<uint8_t>> key;
  mojo::internal::Pointer<mojo::internal::Array_Data<uint8_t>> value;

 private:
  KeyValue_Data();
  ~KeyValue_Data() = delete;
};
static_assert(sizeof(KeyValue_Data) == 24,
              "Bad sizeof(KeyValue_Data)");
// Used by KeyValue::WrapAsMessage to lazily serialize the struct.
template <typename UserType, typename DataView>
struct KeyValue_UnserializedMessageContext
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  KeyValue_UnserializedMessageContext(
    uint32_t message_name,
    uint32_t message_flags,
    UserType input)
      : mojo::internal::UnserializedMessageContext(&kMessageTag, message_name, message_flags)
      , user_data_(std::move(input)) {}
  ~KeyValue_UnserializedMessageContext() override = default;

  UserType TakeData() {
    return std::move(user_data_);
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::internal::SerializationContext* context,
                 mojo::internal::Buffer* buffer) override {
    KeyValue_Data::BufferWriter writer;
    mojo::internal::Serialize<DataView>(user_data_, buffer, &writer, context);
  }

  UserType user_data_;
};

template <typename UserType, typename DataView>
const mojo::internal::UnserializedMessageContext::Tag
    KeyValue_UnserializedMessageContext<UserType, DataView>::kMessageTag = {};
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) StorageAreaObserver_KeyAdded_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(StorageAreaObserver_KeyAdded_Params_Data));
      new (data()) StorageAreaObserver_KeyAdded_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    StorageAreaObserver_KeyAdded_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<StorageAreaObserver_KeyAdded_Params_Data>(index_);
    }
    StorageAreaObserver_KeyAdded_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Array_Data<uint8_t>> key;
  mojo::internal::Pointer<mojo::internal::Array_Data<uint8_t>> value;
  mojo::internal::Pointer<mojo::internal::String_Data> source;

 private:
  StorageAreaObserver_KeyAdded_Params_Data();
  ~StorageAreaObserver_KeyAdded_Params_Data() = delete;
};
static_assert(sizeof(StorageAreaObserver_KeyAdded_Params_Data) == 32,
              "Bad sizeof(StorageAreaObserver_KeyAdded_Params_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) StorageAreaObserver_KeyChanged_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(StorageAreaObserver_KeyChanged_Params_Data));
      new (data()) StorageAreaObserver_KeyChanged_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    StorageAreaObserver_KeyChanged_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<StorageAreaObserver_KeyChanged_Params_Data>(index_);
    }
    StorageAreaObserver_KeyChanged_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Array_Data<uint8_t>> key;
  mojo::internal::Pointer<mojo::internal::Array_Data<uint8_t>> new_value;
  mojo::internal::Pointer<mojo::internal::Array_Data<uint8_t>> old_value;
  mojo::internal::Pointer<mojo::internal::String_Data> source;

 private:
  StorageAreaObserver_KeyChanged_Params_Data();
  ~StorageAreaObserver_KeyChanged_Params_Data() = delete;
};
static_assert(sizeof(StorageAreaObserver_KeyChanged_Params_Data) == 40,
              "Bad sizeof(StorageAreaObserver_KeyChanged_Params_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) StorageAreaObserver_KeyDeleted_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(StorageAreaObserver_KeyDeleted_Params_Data));
      new (data()) StorageAreaObserver_KeyDeleted_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    StorageAreaObserver_KeyDeleted_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<StorageAreaObserver_KeyDeleted_Params_Data>(index_);
    }
    StorageAreaObserver_KeyDeleted_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Array_Data<uint8_t>> key;
  mojo::internal::Pointer<mojo::internal::Array_Data<uint8_t>> old_value;
  mojo::internal::Pointer<mojo::internal::String_Data> source;

 private:
  StorageAreaObserver_KeyDeleted_Params_Data();
  ~StorageAreaObserver_KeyDeleted_Params_Data() = delete;
};
static_assert(sizeof(StorageAreaObserver_KeyDeleted_Params_Data) == 32,
              "Bad sizeof(StorageAreaObserver_KeyDeleted_Params_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) StorageAreaObserver_AllDeleted_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(StorageAreaObserver_AllDeleted_Params_Data));
      new (data()) StorageAreaObserver_AllDeleted_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    StorageAreaObserver_AllDeleted_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<StorageAreaObserver_AllDeleted_Params_Data>(index_);
    }
    StorageAreaObserver_AllDeleted_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::String_Data> source;

 private:
  StorageAreaObserver_AllDeleted_Params_Data();
  ~StorageAreaObserver_AllDeleted_Params_Data() = delete;
};
static_assert(sizeof(StorageAreaObserver_AllDeleted_Params_Data) == 16,
              "Bad sizeof(StorageAreaObserver_AllDeleted_Params_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) StorageAreaObserver_ShouldSendOldValueOnMutations_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(StorageAreaObserver_ShouldSendOldValueOnMutations_Params_Data));
      new (data()) StorageAreaObserver_ShouldSendOldValueOnMutations_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    StorageAreaObserver_ShouldSendOldValueOnMutations_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<StorageAreaObserver_ShouldSendOldValueOnMutations_Params_Data>(index_);
    }
    StorageAreaObserver_ShouldSendOldValueOnMutations_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t value : 1;
  uint8_t padfinal_[7];

 private:
  StorageAreaObserver_ShouldSendOldValueOnMutations_Params_Data();
  ~StorageAreaObserver_ShouldSendOldValueOnMutations_Params_Data() = delete;
};
static_assert(sizeof(StorageAreaObserver_ShouldSendOldValueOnMutations_Params_Data) == 16,
              "Bad sizeof(StorageAreaObserver_ShouldSendOldValueOnMutations_Params_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) StorageAreaGetAllCallback_Complete_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(StorageAreaGetAllCallback_Complete_Params_Data));
      new (data()) StorageAreaGetAllCallback_Complete_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    StorageAreaGetAllCallback_Complete_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<StorageAreaGetAllCallback_Complete_Params_Data>(index_);
    }
    StorageAreaGetAllCallback_Complete_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t success : 1;
  uint8_t padfinal_[7];

 private:
  StorageAreaGetAllCallback_Complete_Params_Data();
  ~StorageAreaGetAllCallback_Complete_Params_Data() = delete;
};
static_assert(sizeof(StorageAreaGetAllCallback_Complete_Params_Data) == 16,
              "Bad sizeof(StorageAreaGetAllCallback_Complete_Params_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) StorageArea_AddObserver_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(StorageArea_AddObserver_Params_Data));
      new (data()) StorageArea_AddObserver_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    StorageArea_AddObserver_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<StorageArea_AddObserver_Params_Data>(index_);
    }
    StorageArea_AddObserver_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::AssociatedInterface_Data observer;

 private:
  StorageArea_AddObserver_Params_Data();
  ~StorageArea_AddObserver_Params_Data() = delete;
};
static_assert(sizeof(StorageArea_AddObserver_Params_Data) == 16,
              "Bad sizeof(StorageArea_AddObserver_Params_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) StorageArea_Put_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(StorageArea_Put_Params_Data));
      new (data()) StorageArea_Put_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    StorageArea_Put_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<StorageArea_Put_Params_Data>(index_);
    }
    StorageArea_Put_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Array_Data<uint8_t>> key;
  mojo::internal::Pointer<mojo::internal::Array_Data<uint8_t>> value;
  mojo::internal::Pointer<mojo::internal::Array_Data<uint8_t>> client_old_value;
  mojo::internal::Pointer<mojo::internal::String_Data> source;

 private:
  StorageArea_Put_Params_Data();
  ~StorageArea_Put_Params_Data() = delete;
};
static_assert(sizeof(StorageArea_Put_Params_Data) == 40,
              "Bad sizeof(StorageArea_Put_Params_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) StorageArea_Put_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(StorageArea_Put_ResponseParams_Data));
      new (data()) StorageArea_Put_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    StorageArea_Put_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<StorageArea_Put_ResponseParams_Data>(index_);
    }
    StorageArea_Put_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t success : 1;
  uint8_t padfinal_[7];

 private:
  StorageArea_Put_ResponseParams_Data();
  ~StorageArea_Put_ResponseParams_Data() = delete;
};
static_assert(sizeof(StorageArea_Put_ResponseParams_Data) == 16,
              "Bad sizeof(StorageArea_Put_ResponseParams_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) StorageArea_Delete_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(StorageArea_Delete_Params_Data));
      new (data()) StorageArea_Delete_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    StorageArea_Delete_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<StorageArea_Delete_Params_Data>(index_);
    }
    StorageArea_Delete_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Array_Data<uint8_t>> key;
  mojo::internal::Pointer<mojo::internal::Array_Data<uint8_t>> client_old_value;
  mojo::internal::Pointer<mojo::internal::String_Data> source;

 private:
  StorageArea_Delete_Params_Data();
  ~StorageArea_Delete_Params_Data() = delete;
};
static_assert(sizeof(StorageArea_Delete_Params_Data) == 32,
              "Bad sizeof(StorageArea_Delete_Params_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) StorageArea_Delete_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(StorageArea_Delete_ResponseParams_Data));
      new (data()) StorageArea_Delete_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    StorageArea_Delete_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<StorageArea_Delete_ResponseParams_Data>(index_);
    }
    StorageArea_Delete_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t success : 1;
  uint8_t padfinal_[7];

 private:
  StorageArea_Delete_ResponseParams_Data();
  ~StorageArea_Delete_ResponseParams_Data() = delete;
};
static_assert(sizeof(StorageArea_Delete_ResponseParams_Data) == 16,
              "Bad sizeof(StorageArea_Delete_ResponseParams_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) StorageArea_DeleteAll_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(StorageArea_DeleteAll_Params_Data));
      new (data()) StorageArea_DeleteAll_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    StorageArea_DeleteAll_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<StorageArea_DeleteAll_Params_Data>(index_);
    }
    StorageArea_DeleteAll_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::String_Data> source;

 private:
  StorageArea_DeleteAll_Params_Data();
  ~StorageArea_DeleteAll_Params_Data() = delete;
};
static_assert(sizeof(StorageArea_DeleteAll_Params_Data) == 16,
              "Bad sizeof(StorageArea_DeleteAll_Params_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) StorageArea_DeleteAll_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(StorageArea_DeleteAll_ResponseParams_Data));
      new (data()) StorageArea_DeleteAll_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    StorageArea_DeleteAll_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<StorageArea_DeleteAll_ResponseParams_Data>(index_);
    }
    StorageArea_DeleteAll_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t success : 1;
  uint8_t padfinal_[7];

 private:
  StorageArea_DeleteAll_ResponseParams_Data();
  ~StorageArea_DeleteAll_ResponseParams_Data() = delete;
};
static_assert(sizeof(StorageArea_DeleteAll_ResponseParams_Data) == 16,
              "Bad sizeof(StorageArea_DeleteAll_ResponseParams_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) StorageArea_Get_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(StorageArea_Get_Params_Data));
      new (data()) StorageArea_Get_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    StorageArea_Get_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<StorageArea_Get_Params_Data>(index_);
    }
    StorageArea_Get_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Array_Data<uint8_t>> key;

 private:
  StorageArea_Get_Params_Data();
  ~StorageArea_Get_Params_Data() = delete;
};
static_assert(sizeof(StorageArea_Get_Params_Data) == 16,
              "Bad sizeof(StorageArea_Get_Params_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) StorageArea_Get_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(StorageArea_Get_ResponseParams_Data));
      new (data()) StorageArea_Get_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    StorageArea_Get_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<StorageArea_Get_ResponseParams_Data>(index_);
    }
    StorageArea_Get_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t success : 1;
  uint8_t pad0_[7];
  mojo::internal::Pointer<mojo::internal::Array_Data<uint8_t>> value;

 private:
  StorageArea_Get_ResponseParams_Data();
  ~StorageArea_Get_ResponseParams_Data() = delete;
};
static_assert(sizeof(StorageArea_Get_ResponseParams_Data) == 24,
              "Bad sizeof(StorageArea_Get_ResponseParams_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) StorageArea_GetAll_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(StorageArea_GetAll_Params_Data));
      new (data()) StorageArea_GetAll_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    StorageArea_GetAll_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<StorageArea_GetAll_Params_Data>(index_);
    }
    StorageArea_GetAll_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::AssociatedInterface_Data complete_callback;

 private:
  StorageArea_GetAll_Params_Data();
  ~StorageArea_GetAll_Params_Data() = delete;
};
static_assert(sizeof(StorageArea_GetAll_Params_Data) == 16,
              "Bad sizeof(StorageArea_GetAll_Params_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) StorageArea_GetAll_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(StorageArea_GetAll_ResponseParams_Data));
      new (data()) StorageArea_GetAll_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    StorageArea_GetAll_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<StorageArea_GetAll_ResponseParams_Data>(index_);
    }
    StorageArea_GetAll_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t success : 1;
  uint8_t pad0_[7];
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<internal::KeyValue_Data>>> data;

 private:
  StorageArea_GetAll_ResponseParams_Data();
  ~StorageArea_GetAll_ResponseParams_Data() = delete;
};
static_assert(sizeof(StorageArea_GetAll_ResponseParams_Data) == 24,
              "Bad sizeof(StorageArea_GetAll_ResponseParams_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace blink

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_DOM_STORAGE_STORAGE_AREA_MOJOM_SHARED_INTERNAL_H_