// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_LOADER_NAVIGATION_PREDICTOR_MOJOM_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_LOADER_NAVIGATION_PREDICTOR_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"

#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#if BUILDFLAG(MOJO_TRACE_ENABLED)
#include "base/trace_event/trace_event.h"
#endif
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "third_party/blink/public/mojom/loader/navigation_predictor.mojom-shared.h"
#include "url/mojom/url.mojom.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/associated_interface_ptr.h"
#include "mojo/public/cpp/bindings/associated_interface_ptr_info.h"
#include "mojo/public/cpp/bindings/associated_interface_request.h"
#include "mojo/public/cpp/bindings/interface_ptr.h"
#include "mojo/public/cpp/bindings/interface_request.h"
#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"
#include "mojo/public/cpp/bindings/thread_safe_interface_ptr.h"


#include "mojo/public/cpp/bindings/lib/native_enum_serialization.h"
#include "mojo/public/cpp/bindings/lib/native_struct_serialization.h"
#include "third_party/blink/common/common_export.h"


namespace blink {
namespace mojom {
class AnchorElementMetricsHost;
using AnchorElementMetricsHostPtr = mojo::InterfacePtr<AnchorElementMetricsHost>;
using AnchorElementMetricsHostPtrInfo = mojo::InterfacePtrInfo<AnchorElementMetricsHost>;
using ThreadSafeAnchorElementMetricsHostPtr =
    mojo::ThreadSafeInterfacePtr<AnchorElementMetricsHost>;
using AnchorElementMetricsHostRequest = mojo::InterfaceRequest<AnchorElementMetricsHost>;
using AnchorElementMetricsHostAssociatedPtr =
    mojo::AssociatedInterfacePtr<AnchorElementMetricsHost>;
using ThreadSafeAnchorElementMetricsHostAssociatedPtr =
    mojo::ThreadSafeAssociatedInterfacePtr<AnchorElementMetricsHost>;
using AnchorElementMetricsHostAssociatedPtrInfo =
    mojo::AssociatedInterfacePtrInfo<AnchorElementMetricsHost>;
using AnchorElementMetricsHostAssociatedRequest =
    mojo::AssociatedInterfaceRequest<AnchorElementMetricsHost>;

class AnchorElementMetrics;
using AnchorElementMetricsPtr = mojo::StructPtr<AnchorElementMetrics>;


class AnchorElementMetricsHostProxy;

template <typename ImplRefTraits>
class AnchorElementMetricsHostStub;

class AnchorElementMetricsHostRequestValidator;

class BLINK_COMMON_EXPORT AnchorElementMetricsHost
    : public AnchorElementMetricsHostInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Proxy_ = AnchorElementMetricsHostProxy;

  template <typename ImplRefTraits>
  using Stub_ = AnchorElementMetricsHostStub<ImplRefTraits>;

  using RequestValidator_ = AnchorElementMetricsHostRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  enum MethodMinVersions : uint32_t {
    kUpdateAnchorElementMetricsMinVersion = 0,
  };
  virtual ~AnchorElementMetricsHost() {}

  virtual void UpdateAnchorElementMetrics(AnchorElementMetricsPtr metrics) = 0;
};
class BLINK_COMMON_EXPORT AnchorElementMetricsHostInterceptorForTesting : public AnchorElementMetricsHost {
  virtual AnchorElementMetricsHost* GetForwardingInterface() = 0;
  void UpdateAnchorElementMetrics(AnchorElementMetricsPtr metrics) override;
};
class BLINK_COMMON_EXPORT AnchorElementMetricsHostAsyncWaiter {
 public:
  explicit AnchorElementMetricsHostAsyncWaiter(AnchorElementMetricsHost* proxy);
  ~AnchorElementMetricsHostAsyncWaiter();

 private:
  AnchorElementMetricsHost* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(AnchorElementMetricsHostAsyncWaiter);
};

class BLINK_COMMON_EXPORT AnchorElementMetricsHostProxy
    : public AnchorElementMetricsHost {
 public:
  explicit AnchorElementMetricsHostProxy(mojo::MessageReceiverWithResponder* receiver);
  void UpdateAnchorElementMetrics(AnchorElementMetricsPtr metrics) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class BLINK_COMMON_EXPORT AnchorElementMetricsHostStubDispatch {
 public:
  static bool Accept(AnchorElementMetricsHost* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      AnchorElementMetricsHost* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<AnchorElementMetricsHost>>
class AnchorElementMetricsHostStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  AnchorElementMetricsHostStub() {}
  ~AnchorElementMetricsHostStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return AnchorElementMetricsHostStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return AnchorElementMetricsHostStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class BLINK_COMMON_EXPORT AnchorElementMetricsHostRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};





class BLINK_COMMON_EXPORT AnchorElementMetrics {
 public:
  using DataView = AnchorElementMetricsDataView;
  using Data_ = internal::AnchorElementMetrics_Data;

  template <typename... Args>
  static AnchorElementMetricsPtr New(Args&&... args) {
    return AnchorElementMetricsPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static AnchorElementMetricsPtr From(const U& u) {
    return mojo::TypeConverter<AnchorElementMetricsPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, AnchorElementMetrics>::Convert(*this);
  }


  AnchorElementMetrics();

  AnchorElementMetrics(
      float ratio_area,
      float ratio_distance_root_top,
      float ratio_distance_center_to_visible_top,
      const GURL& target_url);

  ~AnchorElementMetrics();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = AnchorElementMetricsPtr>
  AnchorElementMetricsPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T,
            typename std::enable_if<std::is_same<
                T, AnchorElementMetrics>::value>::type* = nullptr>
  bool Equals(const T& other) const;

  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        AnchorElementMetrics::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        AnchorElementMetrics::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::AnchorElementMetrics_UnserializedMessageContext<
            UserType, AnchorElementMetrics::DataView>>(0, 0, std::move(input)));
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    return mojo::internal::DeserializeImpl<AnchorElementMetrics::DataView>(
        data, data_num_bytes, std::vector<mojo::ScopedHandle>(), output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return AnchorElementMetrics::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::AnchorElementMetrics_UnserializedMessageContext<
            UserType, AnchorElementMetrics::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<AnchorElementMetrics::DataView>(
        input.payload(), input.payload_num_bytes(),
        std::move(*input.mutable_handles()), output, Validate);
  }

  float ratio_area;
  float ratio_distance_root_top;
  float ratio_distance_center_to_visible_top;
  GURL target_url;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

template <typename StructPtrType>
AnchorElementMetricsPtr AnchorElementMetrics::Clone() const {
  return New(
      mojo::Clone(ratio_area),
      mojo::Clone(ratio_distance_root_top),
      mojo::Clone(ratio_distance_center_to_visible_top),
      mojo::Clone(target_url)
  );
}

template <typename T,
          typename std::enable_if<std::is_same<
              T, AnchorElementMetrics>::value>::type*>
bool AnchorElementMetrics::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->ratio_area, other_struct.ratio_area))
    return false;
  if (!mojo::Equals(this->ratio_distance_root_top, other_struct.ratio_distance_root_top))
    return false;
  if (!mojo::Equals(this->ratio_distance_center_to_visible_top, other_struct.ratio_distance_center_to_visible_top))
    return false;
  if (!mojo::Equals(this->target_url, other_struct.target_url))
    return false;
  return true;
}


}  // namespace mojom
}  // namespace blink

namespace mojo {


template <>
struct BLINK_COMMON_EXPORT StructTraits<::blink::mojom::AnchorElementMetrics::DataView,
                                         ::blink::mojom::AnchorElementMetricsPtr> {
  static bool IsNull(const ::blink::mojom::AnchorElementMetricsPtr& input) { return !input; }
  static void SetToNull(::blink::mojom::AnchorElementMetricsPtr* output) { output->reset(); }

  static decltype(::blink::mojom::AnchorElementMetrics::ratio_area) ratio_area(
      const ::blink::mojom::AnchorElementMetricsPtr& input) {
    return input->ratio_area;
  }

  static decltype(::blink::mojom::AnchorElementMetrics::ratio_distance_root_top) ratio_distance_root_top(
      const ::blink::mojom::AnchorElementMetricsPtr& input) {
    return input->ratio_distance_root_top;
  }

  static decltype(::blink::mojom::AnchorElementMetrics::ratio_distance_center_to_visible_top) ratio_distance_center_to_visible_top(
      const ::blink::mojom::AnchorElementMetricsPtr& input) {
    return input->ratio_distance_center_to_visible_top;
  }

  static const decltype(::blink::mojom::AnchorElementMetrics::target_url)& target_url(
      const ::blink::mojom::AnchorElementMetricsPtr& input) {
    return input->target_url;
  }

  static bool Read(::blink::mojom::AnchorElementMetrics::DataView input, ::blink::mojom::AnchorElementMetricsPtr* output);
};

}  // namespace mojo

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_LOADER_NAVIGATION_PREDICTOR_MOJOM_H_