// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_PLUGINS_PLUGIN_REGISTRY_MOJOM_SHARED_INTERNAL_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_PLUGINS_PLUGIN_REGISTRY_MOJOM_SHARED_INTERNAL_H_

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "mojo/public/mojom/base/file_path.mojom-shared-internal.h"
#include "mojo/public/mojom/base/string16.mojom-shared-internal.h"
#include "url/mojom/origin.mojom-shared-internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/interfaces/bindings/native_struct.mojom-shared-internal.h"
#include "base/component_export.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace blink {
namespace mojom {
namespace internal {
class PluginMimeType_Data;
class PluginInfo_Data;

#pragma pack(push, 1)
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) PluginMimeType_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(PluginMimeType_Data));
      new (data()) PluginMimeType_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    PluginMimeType_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<PluginMimeType_Data>(index_);
    }
    PluginMimeType_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::String_Data> mime_type;
  mojo::internal::Pointer<::mojo_base::mojom::internal::String16_Data> description;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<mojo::internal::String_Data>>> file_extensions;

 private:
  PluginMimeType_Data();
  ~PluginMimeType_Data() = delete;
};
static_assert(sizeof(PluginMimeType_Data) == 32,
              "Bad sizeof(PluginMimeType_Data)");
// Used by PluginMimeType::WrapAsMessage to lazily serialize the struct.
template <typename UserType, typename DataView>
struct PluginMimeType_UnserializedMessageContext
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  PluginMimeType_UnserializedMessageContext(
    uint32_t message_name,
    uint32_t message_flags,
    UserType input)
      : mojo::internal::UnserializedMessageContext(&kMessageTag, message_name, message_flags)
      , user_data_(std::move(input)) {}
  ~PluginMimeType_UnserializedMessageContext() override = default;

  UserType TakeData() {
    return std::move(user_data_);
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::internal::SerializationContext* context,
                 mojo::internal::Buffer* buffer) override {
    PluginMimeType_Data::BufferWriter writer;
    mojo::internal::Serialize<DataView>(user_data_, buffer, &writer, context);
  }

  UserType user_data_;
};

template <typename UserType, typename DataView>
const mojo::internal::UnserializedMessageContext::Tag
    PluginMimeType_UnserializedMessageContext<UserType, DataView>::kMessageTag = {};
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) PluginInfo_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(PluginInfo_Data));
      new (data()) PluginInfo_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    PluginInfo_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<PluginInfo_Data>(index_);
    }
    PluginInfo_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::mojo_base::mojom::internal::String16_Data> name;
  mojo::internal::Pointer<::mojo_base::mojom::internal::String16_Data> description;
  mojo::internal::Pointer<::mojo_base::mojom::internal::FilePath_Data> filename;
  uint32_t background_color;
  uint8_t pad3_[4];
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<internal::PluginMimeType_Data>>> mime_types;

 private:
  PluginInfo_Data();
  ~PluginInfo_Data() = delete;
};
static_assert(sizeof(PluginInfo_Data) == 48,
              "Bad sizeof(PluginInfo_Data)");
// Used by PluginInfo::WrapAsMessage to lazily serialize the struct.
template <typename UserType, typename DataView>
struct PluginInfo_UnserializedMessageContext
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  PluginInfo_UnserializedMessageContext(
    uint32_t message_name,
    uint32_t message_flags,
    UserType input)
      : mojo::internal::UnserializedMessageContext(&kMessageTag, message_name, message_flags)
      , user_data_(std::move(input)) {}
  ~PluginInfo_UnserializedMessageContext() override = default;

  UserType TakeData() {
    return std::move(user_data_);
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::internal::SerializationContext* context,
                 mojo::internal::Buffer* buffer) override {
    PluginInfo_Data::BufferWriter writer;
    mojo::internal::Serialize<DataView>(user_data_, buffer, &writer, context);
  }

  UserType user_data_;
};

template <typename UserType, typename DataView>
const mojo::internal::UnserializedMessageContext::Tag
    PluginInfo_UnserializedMessageContext<UserType, DataView>::kMessageTag = {};
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) PluginRegistry_GetPlugins_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(PluginRegistry_GetPlugins_Params_Data));
      new (data()) PluginRegistry_GetPlugins_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    PluginRegistry_GetPlugins_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<PluginRegistry_GetPlugins_Params_Data>(index_);
    }
    PluginRegistry_GetPlugins_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t refresh : 1;
  uint8_t pad0_[7];
  mojo::internal::Pointer<::url::mojom::internal::Origin_Data> main_frame_origin;

 private:
  PluginRegistry_GetPlugins_Params_Data();
  ~PluginRegistry_GetPlugins_Params_Data() = delete;
};
static_assert(sizeof(PluginRegistry_GetPlugins_Params_Data) == 24,
              "Bad sizeof(PluginRegistry_GetPlugins_Params_Data)");
class COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) PluginRegistry_GetPlugins_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(PluginRegistry_GetPlugins_ResponseParams_Data));
      new (data()) PluginRegistry_GetPlugins_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    PluginRegistry_GetPlugins_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<PluginRegistry_GetPlugins_ResponseParams_Data>(index_);
    }
    PluginRegistry_GetPlugins_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<internal::PluginInfo_Data>>> plugins;

 private:
  PluginRegistry_GetPlugins_ResponseParams_Data();
  ~PluginRegistry_GetPlugins_ResponseParams_Data() = delete;
};
static_assert(sizeof(PluginRegistry_GetPlugins_ResponseParams_Data) == 16,
              "Bad sizeof(PluginRegistry_GetPlugins_ResponseParams_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace blink

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_PLUGINS_PLUGIN_REGISTRY_MOJOM_SHARED_INTERNAL_H_