// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_SHARED_WORKER_SHARED_WORKER_CREATION_CONTEXT_TYPE_MOJOM_SHARED_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_SHARED_WORKER_SHARED_WORKER_CREATION_CONTEXT_TYPE_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <ostream>
#include <type_traits>
#include <utility>

#include "base/compiler_specific.h"
#include "base/containers/flat_map.h"
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"
#include "third_party/blink/public/mojom/shared_worker/shared_worker_creation_context_type.mojom-shared-internal.h"

#include "mojo/public/cpp/bindings/lib/interface_serialization.h"


#include "mojo/public/cpp/bindings/native_enum.h"
#include "mojo/public/cpp/bindings/lib/native_struct_serialization.h"
#include "base/component_export.h"


namespace blink {
namespace mojom {


}  // namespace mojom
}  // namespace blink

namespace mojo {
namespace internal {

}  // namespace internal
}  // namespace mojo


namespace blink {
namespace mojom {

enum class SharedWorkerCreationContextType : int32_t {
  kNonsecure,
  kSecure,
  kMinValue = 0,
  kMaxValue = 1,
};

inline std::ostream& operator<<(std::ostream& os, SharedWorkerCreationContextType value) {
  switch(value) {
    case SharedWorkerCreationContextType::kNonsecure:
      return os << "SharedWorkerCreationContextType::kNonsecure";
    case SharedWorkerCreationContextType::kSecure:
      return os << "SharedWorkerCreationContextType::kSecure";
    default:
      return os << "Unknown SharedWorkerCreationContextType value: " << static_cast<int32_t>(value);
  }
}
inline bool IsKnownEnumValue(SharedWorkerCreationContextType value) {
  return internal::SharedWorkerCreationContextType_Data::IsKnownValue(
      static_cast<int32_t>(value));
}


}  // namespace mojom
}  // namespace blink

namespace std {

template <>
struct hash<::blink::mojom::SharedWorkerCreationContextType>
    : public mojo::internal::EnumHashImpl<::blink::mojom::SharedWorkerCreationContextType> {};

}  // namespace std

namespace mojo {


template <>
struct EnumTraits<::blink::mojom::SharedWorkerCreationContextType, ::blink::mojom::SharedWorkerCreationContextType> {
  static ::blink::mojom::SharedWorkerCreationContextType ToMojom(::blink::mojom::SharedWorkerCreationContextType input) { return input; }
  static bool FromMojom(::blink::mojom::SharedWorkerCreationContextType input, ::blink::mojom::SharedWorkerCreationContextType* output) {
    *output = input;
    return true;
  }
};

namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::SharedWorkerCreationContextType, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::blink::mojom::SharedWorkerCreationContextType, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(static_cast<::blink::mojom::SharedWorkerCreationContextType>(input), output);
  }
};

}  // namespace internal

}  // namespace mojo


namespace blink {
namespace mojom {


}  // namespace mojom
}  // namespace blink

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_SHARED_WORKER_SHARED_WORKER_CREATION_CONTEXT_TYPE_MOJOM_SHARED_H_
