// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef UI_OZONE_PUBLIC_INTERFACES_DRM_DEVICE_MOJOM_SHARED_INTERNAL_H_
#define UI_OZONE_PUBLIC_INTERFACES_DRM_DEVICE_MOJOM_SHARED_INTERNAL_H_

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "mojo/public/mojom/base/file.mojom-shared-internal.h"
#include "mojo/public/mojom/base/file_path.mojom-shared-internal.h"
#include "ui/display/mojo/display_constants.mojom-shared-internal.h"
#include "ui/display/mojo/display_mode.mojom-shared-internal.h"
#include "ui/display/mojo/display_snapshot.mojom-shared-internal.h"
#include "ui/display/mojo/gamma_ramp_rgb_entry.mojom-shared-internal.h"
#include "ui/gfx/geometry/mojo/geometry.mojom-shared-internal.h"
#include "ui/gfx/mojo/accelerated_widget.mojom-shared-internal.h"
#include "ui/ozone/public/interfaces/overlay_surface_candidate.mojom-shared-internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/interfaces/bindings/native_struct.mojom-shared-internal.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace ui {
namespace ozone {
namespace mojom {
namespace internal {

#pragma pack(push, 1)
class  DrmDevice_StartDrmDevice_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(DrmDevice_StartDrmDevice_Params_Data));
      new (data()) DrmDevice_StartDrmDevice_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    DrmDevice_StartDrmDevice_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<DrmDevice_StartDrmDevice_Params_Data>(index_);
    }
    DrmDevice_StartDrmDevice_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  DrmDevice_StartDrmDevice_Params_Data();
  ~DrmDevice_StartDrmDevice_Params_Data() = delete;
};
static_assert(sizeof(DrmDevice_StartDrmDevice_Params_Data) == 8,
              "Bad sizeof(DrmDevice_StartDrmDevice_Params_Data)");
class  DrmDevice_StartDrmDevice_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(DrmDevice_StartDrmDevice_ResponseParams_Data));
      new (data()) DrmDevice_StartDrmDevice_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    DrmDevice_StartDrmDevice_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<DrmDevice_StartDrmDevice_ResponseParams_Data>(index_);
    }
    DrmDevice_StartDrmDevice_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t success : 1;
  uint8_t padfinal_[7];

 private:
  DrmDevice_StartDrmDevice_ResponseParams_Data();
  ~DrmDevice_StartDrmDevice_ResponseParams_Data() = delete;
};
static_assert(sizeof(DrmDevice_StartDrmDevice_ResponseParams_Data) == 16,
              "Bad sizeof(DrmDevice_StartDrmDevice_ResponseParams_Data)");
class  DrmDevice_CreateWindow_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(DrmDevice_CreateWindow_Params_Data));
      new (data()) DrmDevice_CreateWindow_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    DrmDevice_CreateWindow_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<DrmDevice_CreateWindow_Params_Data>(index_);
    }
    DrmDevice_CreateWindow_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::gfx::mojom::internal::AcceleratedWidget_Data> widget;

 private:
  DrmDevice_CreateWindow_Params_Data();
  ~DrmDevice_CreateWindow_Params_Data() = delete;
};
static_assert(sizeof(DrmDevice_CreateWindow_Params_Data) == 16,
              "Bad sizeof(DrmDevice_CreateWindow_Params_Data)");
class  DrmDevice_DestroyWindow_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(DrmDevice_DestroyWindow_Params_Data));
      new (data()) DrmDevice_DestroyWindow_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    DrmDevice_DestroyWindow_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<DrmDevice_DestroyWindow_Params_Data>(index_);
    }
    DrmDevice_DestroyWindow_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::gfx::mojom::internal::AcceleratedWidget_Data> widget;

 private:
  DrmDevice_DestroyWindow_Params_Data();
  ~DrmDevice_DestroyWindow_Params_Data() = delete;
};
static_assert(sizeof(DrmDevice_DestroyWindow_Params_Data) == 16,
              "Bad sizeof(DrmDevice_DestroyWindow_Params_Data)");
class  DrmDevice_SetWindowBounds_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(DrmDevice_SetWindowBounds_Params_Data));
      new (data()) DrmDevice_SetWindowBounds_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    DrmDevice_SetWindowBounds_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<DrmDevice_SetWindowBounds_Params_Data>(index_);
    }
    DrmDevice_SetWindowBounds_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::gfx::mojom::internal::AcceleratedWidget_Data> widget;
  mojo::internal::Pointer<::gfx::mojom::internal::Rect_Data> bounds;

 private:
  DrmDevice_SetWindowBounds_Params_Data();
  ~DrmDevice_SetWindowBounds_Params_Data() = delete;
};
static_assert(sizeof(DrmDevice_SetWindowBounds_Params_Data) == 24,
              "Bad sizeof(DrmDevice_SetWindowBounds_Params_Data)");
class  DrmDevice_TakeDisplayControl_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(DrmDevice_TakeDisplayControl_Params_Data));
      new (data()) DrmDevice_TakeDisplayControl_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    DrmDevice_TakeDisplayControl_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<DrmDevice_TakeDisplayControl_Params_Data>(index_);
    }
    DrmDevice_TakeDisplayControl_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  DrmDevice_TakeDisplayControl_Params_Data();
  ~DrmDevice_TakeDisplayControl_Params_Data() = delete;
};
static_assert(sizeof(DrmDevice_TakeDisplayControl_Params_Data) == 8,
              "Bad sizeof(DrmDevice_TakeDisplayControl_Params_Data)");
class  DrmDevice_TakeDisplayControl_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(DrmDevice_TakeDisplayControl_ResponseParams_Data));
      new (data()) DrmDevice_TakeDisplayControl_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    DrmDevice_TakeDisplayControl_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<DrmDevice_TakeDisplayControl_ResponseParams_Data>(index_);
    }
    DrmDevice_TakeDisplayControl_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t success : 1;
  uint8_t padfinal_[7];

 private:
  DrmDevice_TakeDisplayControl_ResponseParams_Data();
  ~DrmDevice_TakeDisplayControl_ResponseParams_Data() = delete;
};
static_assert(sizeof(DrmDevice_TakeDisplayControl_ResponseParams_Data) == 16,
              "Bad sizeof(DrmDevice_TakeDisplayControl_ResponseParams_Data)");
class  DrmDevice_RelinquishDisplayControl_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(DrmDevice_RelinquishDisplayControl_Params_Data));
      new (data()) DrmDevice_RelinquishDisplayControl_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    DrmDevice_RelinquishDisplayControl_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<DrmDevice_RelinquishDisplayControl_Params_Data>(index_);
    }
    DrmDevice_RelinquishDisplayControl_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  DrmDevice_RelinquishDisplayControl_Params_Data();
  ~DrmDevice_RelinquishDisplayControl_Params_Data() = delete;
};
static_assert(sizeof(DrmDevice_RelinquishDisplayControl_Params_Data) == 8,
              "Bad sizeof(DrmDevice_RelinquishDisplayControl_Params_Data)");
class  DrmDevice_RelinquishDisplayControl_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(DrmDevice_RelinquishDisplayControl_ResponseParams_Data));
      new (data()) DrmDevice_RelinquishDisplayControl_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    DrmDevice_RelinquishDisplayControl_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<DrmDevice_RelinquishDisplayControl_ResponseParams_Data>(index_);
    }
    DrmDevice_RelinquishDisplayControl_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  uint8_t success : 1;
  uint8_t padfinal_[7];

 private:
  DrmDevice_RelinquishDisplayControl_ResponseParams_Data();
  ~DrmDevice_RelinquishDisplayControl_ResponseParams_Data() = delete;
};
static_assert(sizeof(DrmDevice_RelinquishDisplayControl_ResponseParams_Data) == 16,
              "Bad sizeof(DrmDevice_RelinquishDisplayControl_ResponseParams_Data)");
class  DrmDevice_RefreshNativeDisplays_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(DrmDevice_RefreshNativeDisplays_Params_Data));
      new (data()) DrmDevice_RefreshNativeDisplays_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    DrmDevice_RefreshNativeDisplays_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<DrmDevice_RefreshNativeDisplays_Params_Data>(index_);
    }
    DrmDevice_RefreshNativeDisplays_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  DrmDevice_RefreshNativeDisplays_Params_Data();
  ~DrmDevice_RefreshNativeDisplays_Params_Data() = delete;
};
static_assert(sizeof(DrmDevice_RefreshNativeDisplays_Params_Data) == 8,
              "Bad sizeof(DrmDevice_RefreshNativeDisplays_Params_Data)");
class  DrmDevice_RefreshNativeDisplays_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(DrmDevice_RefreshNativeDisplays_ResponseParams_Data));
      new (data()) DrmDevice_RefreshNativeDisplays_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    DrmDevice_RefreshNativeDisplays_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<DrmDevice_RefreshNativeDisplays_ResponseParams_Data>(index_);
    }
    DrmDevice_RefreshNativeDisplays_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<::display::mojom::internal::DisplaySnapshot_Data>>> display_snapshots;

 private:
  DrmDevice_RefreshNativeDisplays_ResponseParams_Data();
  ~DrmDevice_RefreshNativeDisplays_ResponseParams_Data() = delete;
};
static_assert(sizeof(DrmDevice_RefreshNativeDisplays_ResponseParams_Data) == 16,
              "Bad sizeof(DrmDevice_RefreshNativeDisplays_ResponseParams_Data)");
class  DrmDevice_AddGraphicsDevice_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(DrmDevice_AddGraphicsDevice_Params_Data));
      new (data()) DrmDevice_AddGraphicsDevice_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    DrmDevice_AddGraphicsDevice_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<DrmDevice_AddGraphicsDevice_Params_Data>(index_);
    }
    DrmDevice_AddGraphicsDevice_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::mojo_base::mojom::internal::FilePath_Data> path;
  mojo::internal::Pointer<::mojo_base::mojom::internal::File_Data> file;

 private:
  DrmDevice_AddGraphicsDevice_Params_Data();
  ~DrmDevice_AddGraphicsDevice_Params_Data() = delete;
};
static_assert(sizeof(DrmDevice_AddGraphicsDevice_Params_Data) == 24,
              "Bad sizeof(DrmDevice_AddGraphicsDevice_Params_Data)");
class  DrmDevice_RemoveGraphicsDevice_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(DrmDevice_RemoveGraphicsDevice_Params_Data));
      new (data()) DrmDevice_RemoveGraphicsDevice_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    DrmDevice_RemoveGraphicsDevice_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<DrmDevice_RemoveGraphicsDevice_Params_Data>(index_);
    }
    DrmDevice_RemoveGraphicsDevice_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::mojo_base::mojom::internal::FilePath_Data> path;

 private:
  DrmDevice_RemoveGraphicsDevice_Params_Data();
  ~DrmDevice_RemoveGraphicsDevice_Params_Data() = delete;
};
static_assert(sizeof(DrmDevice_RemoveGraphicsDevice_Params_Data) == 16,
              "Bad sizeof(DrmDevice_RemoveGraphicsDevice_Params_Data)");
class  DrmDevice_DisableNativeDisplay_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(DrmDevice_DisableNativeDisplay_Params_Data));
      new (data()) DrmDevice_DisableNativeDisplay_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    DrmDevice_DisableNativeDisplay_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<DrmDevice_DisableNativeDisplay_Params_Data>(index_);
    }
    DrmDevice_DisableNativeDisplay_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int64_t display_id;

 private:
  DrmDevice_DisableNativeDisplay_Params_Data();
  ~DrmDevice_DisableNativeDisplay_Params_Data() = delete;
};
static_assert(sizeof(DrmDevice_DisableNativeDisplay_Params_Data) == 16,
              "Bad sizeof(DrmDevice_DisableNativeDisplay_Params_Data)");
class  DrmDevice_DisableNativeDisplay_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(DrmDevice_DisableNativeDisplay_ResponseParams_Data));
      new (data()) DrmDevice_DisableNativeDisplay_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    DrmDevice_DisableNativeDisplay_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<DrmDevice_DisableNativeDisplay_ResponseParams_Data>(index_);
    }
    DrmDevice_DisableNativeDisplay_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int64_t display_id;
  uint8_t success : 1;
  uint8_t padfinal_[7];

 private:
  DrmDevice_DisableNativeDisplay_ResponseParams_Data();
  ~DrmDevice_DisableNativeDisplay_ResponseParams_Data() = delete;
};
static_assert(sizeof(DrmDevice_DisableNativeDisplay_ResponseParams_Data) == 24,
              "Bad sizeof(DrmDevice_DisableNativeDisplay_ResponseParams_Data)");
class  DrmDevice_ConfigureNativeDisplay_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(DrmDevice_ConfigureNativeDisplay_Params_Data));
      new (data()) DrmDevice_ConfigureNativeDisplay_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    DrmDevice_ConfigureNativeDisplay_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<DrmDevice_ConfigureNativeDisplay_Params_Data>(index_);
    }
    DrmDevice_ConfigureNativeDisplay_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int64_t display_id;
  mojo::internal::Pointer<::display::mojom::internal::DisplayMode_Data> display_mode;
  mojo::internal::Pointer<::gfx::mojom::internal::Point_Data> point;

 private:
  DrmDevice_ConfigureNativeDisplay_Params_Data();
  ~DrmDevice_ConfigureNativeDisplay_Params_Data() = delete;
};
static_assert(sizeof(DrmDevice_ConfigureNativeDisplay_Params_Data) == 32,
              "Bad sizeof(DrmDevice_ConfigureNativeDisplay_Params_Data)");
class  DrmDevice_ConfigureNativeDisplay_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(DrmDevice_ConfigureNativeDisplay_ResponseParams_Data));
      new (data()) DrmDevice_ConfigureNativeDisplay_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    DrmDevice_ConfigureNativeDisplay_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<DrmDevice_ConfigureNativeDisplay_ResponseParams_Data>(index_);
    }
    DrmDevice_ConfigureNativeDisplay_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int64_t display_id;
  uint8_t success : 1;
  uint8_t padfinal_[7];

 private:
  DrmDevice_ConfigureNativeDisplay_ResponseParams_Data();
  ~DrmDevice_ConfigureNativeDisplay_ResponseParams_Data() = delete;
};
static_assert(sizeof(DrmDevice_ConfigureNativeDisplay_ResponseParams_Data) == 24,
              "Bad sizeof(DrmDevice_ConfigureNativeDisplay_ResponseParams_Data)");
class  DrmDevice_GetHDCPState_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(DrmDevice_GetHDCPState_Params_Data));
      new (data()) DrmDevice_GetHDCPState_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    DrmDevice_GetHDCPState_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<DrmDevice_GetHDCPState_Params_Data>(index_);
    }
    DrmDevice_GetHDCPState_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int64_t display_id;

 private:
  DrmDevice_GetHDCPState_Params_Data();
  ~DrmDevice_GetHDCPState_Params_Data() = delete;
};
static_assert(sizeof(DrmDevice_GetHDCPState_Params_Data) == 16,
              "Bad sizeof(DrmDevice_GetHDCPState_Params_Data)");
class  DrmDevice_GetHDCPState_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(DrmDevice_GetHDCPState_ResponseParams_Data));
      new (data()) DrmDevice_GetHDCPState_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    DrmDevice_GetHDCPState_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<DrmDevice_GetHDCPState_ResponseParams_Data>(index_);
    }
    DrmDevice_GetHDCPState_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int64_t display_id;
  uint8_t success : 1;
  uint8_t pad1_[3];
  int32_t state;

 private:
  DrmDevice_GetHDCPState_ResponseParams_Data();
  ~DrmDevice_GetHDCPState_ResponseParams_Data() = delete;
};
static_assert(sizeof(DrmDevice_GetHDCPState_ResponseParams_Data) == 24,
              "Bad sizeof(DrmDevice_GetHDCPState_ResponseParams_Data)");
class  DrmDevice_SetHDCPState_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(DrmDevice_SetHDCPState_Params_Data));
      new (data()) DrmDevice_SetHDCPState_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    DrmDevice_SetHDCPState_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<DrmDevice_SetHDCPState_Params_Data>(index_);
    }
    DrmDevice_SetHDCPState_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int64_t display_id;
  int32_t state;
  uint8_t padfinal_[4];

 private:
  DrmDevice_SetHDCPState_Params_Data();
  ~DrmDevice_SetHDCPState_Params_Data() = delete;
};
static_assert(sizeof(DrmDevice_SetHDCPState_Params_Data) == 24,
              "Bad sizeof(DrmDevice_SetHDCPState_Params_Data)");
class  DrmDevice_SetHDCPState_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(DrmDevice_SetHDCPState_ResponseParams_Data));
      new (data()) DrmDevice_SetHDCPState_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    DrmDevice_SetHDCPState_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<DrmDevice_SetHDCPState_ResponseParams_Data>(index_);
    }
    DrmDevice_SetHDCPState_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int64_t display_id;
  uint8_t success : 1;
  uint8_t padfinal_[7];

 private:
  DrmDevice_SetHDCPState_ResponseParams_Data();
  ~DrmDevice_SetHDCPState_ResponseParams_Data() = delete;
};
static_assert(sizeof(DrmDevice_SetHDCPState_ResponseParams_Data) == 24,
              "Bad sizeof(DrmDevice_SetHDCPState_ResponseParams_Data)");
class  DrmDevice_SetColorMatrix_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(DrmDevice_SetColorMatrix_Params_Data));
      new (data()) DrmDevice_SetColorMatrix_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    DrmDevice_SetColorMatrix_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<DrmDevice_SetColorMatrix_Params_Data>(index_);
    }
    DrmDevice_SetColorMatrix_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int64_t display_id;
  mojo::internal::Pointer<mojo::internal::Array_Data<float>> color_matrix;

 private:
  DrmDevice_SetColorMatrix_Params_Data();
  ~DrmDevice_SetColorMatrix_Params_Data() = delete;
};
static_assert(sizeof(DrmDevice_SetColorMatrix_Params_Data) == 24,
              "Bad sizeof(DrmDevice_SetColorMatrix_Params_Data)");
class  DrmDevice_SetGammaCorrection_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(DrmDevice_SetGammaCorrection_Params_Data));
      new (data()) DrmDevice_SetGammaCorrection_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    DrmDevice_SetGammaCorrection_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<DrmDevice_SetGammaCorrection_Params_Data>(index_);
    }
    DrmDevice_SetGammaCorrection_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int64_t display_id;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<::display::mojom::internal::GammaRampRGBEntry_Data>>> degamma_lut;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<::display::mojom::internal::GammaRampRGBEntry_Data>>> gamma_lut;

 private:
  DrmDevice_SetGammaCorrection_Params_Data();
  ~DrmDevice_SetGammaCorrection_Params_Data() = delete;
};
static_assert(sizeof(DrmDevice_SetGammaCorrection_Params_Data) == 32,
              "Bad sizeof(DrmDevice_SetGammaCorrection_Params_Data)");
class  DrmDevice_CheckOverlayCapabilities_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(DrmDevice_CheckOverlayCapabilities_Params_Data));
      new (data()) DrmDevice_CheckOverlayCapabilities_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    DrmDevice_CheckOverlayCapabilities_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<DrmDevice_CheckOverlayCapabilities_Params_Data>(index_);
    }
    DrmDevice_CheckOverlayCapabilities_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::gfx::mojom::internal::AcceleratedWidget_Data> widget;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<::ui::ozone::mojom::internal::OverlaySurfaceCandidate_Data>>> candidates;

 private:
  DrmDevice_CheckOverlayCapabilities_Params_Data();
  ~DrmDevice_CheckOverlayCapabilities_Params_Data() = delete;
};
static_assert(sizeof(DrmDevice_CheckOverlayCapabilities_Params_Data) == 24,
              "Bad sizeof(DrmDevice_CheckOverlayCapabilities_Params_Data)");
class  DrmDevice_CheckOverlayCapabilities_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(DrmDevice_CheckOverlayCapabilities_ResponseParams_Data));
      new (data()) DrmDevice_CheckOverlayCapabilities_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    DrmDevice_CheckOverlayCapabilities_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<DrmDevice_CheckOverlayCapabilities_ResponseParams_Data>(index_);
    }
    DrmDevice_CheckOverlayCapabilities_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Pointer<::gfx::mojom::internal::AcceleratedWidget_Data> widget;
  mojo::internal::Pointer<mojo::internal::Array_Data<mojo::internal::Pointer<::ui::ozone::mojom::internal::OverlaySurfaceCandidate_Data>>> candidates;
  mojo::internal::Pointer<mojo::internal::Array_Data<int32_t>> status;

 private:
  DrmDevice_CheckOverlayCapabilities_ResponseParams_Data();
  ~DrmDevice_CheckOverlayCapabilities_ResponseParams_Data() = delete;
};
static_assert(sizeof(DrmDevice_CheckOverlayCapabilities_ResponseParams_Data) == 32,
              "Bad sizeof(DrmDevice_CheckOverlayCapabilities_ResponseParams_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace ozone
}  // namespace ui

#endif  // UI_OZONE_PUBLIC_INTERFACES_DRM_DEVICE_MOJOM_SHARED_INTERNAL_H_