// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef UI_OZONE_PUBLIC_INTERFACES_DRM_DEVICE_MOJOM_SHARED_H_
#define UI_OZONE_PUBLIC_INTERFACES_DRM_DEVICE_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <ostream>
#include <type_traits>
#include <utility>

#include "base/compiler_specific.h"
#include "base/containers/flat_map.h"
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"
#include "ui/ozone/public/interfaces/drm_device.mojom-shared-internal.h"
#include "mojo/public/mojom/base/file.mojom-shared.h"
#include "mojo/public/mojom/base/file_path.mojom-shared.h"
#include "ui/display/mojo/display_constants.mojom-shared.h"
#include "ui/display/mojo/display_mode.mojom-shared.h"
#include "ui/display/mojo/display_snapshot.mojom-shared.h"
#include "ui/display/mojo/gamma_ramp_rgb_entry.mojom-shared.h"
#include "ui/gfx/geometry/mojo/geometry.mojom-shared.h"
#include "ui/gfx/mojo/accelerated_widget.mojom-shared.h"
#include "ui/ozone/public/interfaces/overlay_surface_candidate.mojom-shared.h"

#include "mojo/public/cpp/bindings/lib/interface_serialization.h"


#include "mojo/public/cpp/bindings/native_enum.h"
#include "mojo/public/cpp/bindings/lib/native_struct_serialization.h"


namespace ui {
namespace ozone {
namespace mojom {


}  // namespace mojom
}  // namespace ozone
}  // namespace ui

namespace mojo {
namespace internal {

}  // namespace internal
}  // namespace mojo


namespace ui {
namespace ozone {
namespace mojom {
// Interface base classes. They are used for type safety check.
class DrmDeviceInterfaceBase {};

using DrmDevicePtrDataView =
    mojo::InterfacePtrDataView<DrmDeviceInterfaceBase>;
using DrmDeviceRequestDataView =
    mojo::InterfaceRequestDataView<DrmDeviceInterfaceBase>;
using DrmDeviceAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<DrmDeviceInterfaceBase>;
using DrmDeviceAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<DrmDeviceInterfaceBase>;
class DrmDevice_StartDrmDevice_ParamsDataView {
 public:
  DrmDevice_StartDrmDevice_ParamsDataView() {}

  DrmDevice_StartDrmDevice_ParamsDataView(
      internal::DrmDevice_StartDrmDevice_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::DrmDevice_StartDrmDevice_Params_Data* data_ = nullptr;
};

class DrmDevice_StartDrmDevice_ResponseParamsDataView {
 public:
  DrmDevice_StartDrmDevice_ResponseParamsDataView() {}

  DrmDevice_StartDrmDevice_ResponseParamsDataView(
      internal::DrmDevice_StartDrmDevice_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  bool success() const {
    return data_->success;
  }
 private:
  internal::DrmDevice_StartDrmDevice_ResponseParams_Data* data_ = nullptr;
};

class DrmDevice_CreateWindow_ParamsDataView {
 public:
  DrmDevice_CreateWindow_ParamsDataView() {}

  DrmDevice_CreateWindow_ParamsDataView(
      internal::DrmDevice_CreateWindow_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetWidgetDataView(
      ::gfx::mojom::AcceleratedWidgetDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadWidget(UserType* output) {
    auto* pointer = data_->widget.Get();
    return mojo::internal::Deserialize<::gfx::mojom::AcceleratedWidgetDataView>(
        pointer, output, context_);
  }
 private:
  internal::DrmDevice_CreateWindow_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class DrmDevice_DestroyWindow_ParamsDataView {
 public:
  DrmDevice_DestroyWindow_ParamsDataView() {}

  DrmDevice_DestroyWindow_ParamsDataView(
      internal::DrmDevice_DestroyWindow_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetWidgetDataView(
      ::gfx::mojom::AcceleratedWidgetDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadWidget(UserType* output) {
    auto* pointer = data_->widget.Get();
    return mojo::internal::Deserialize<::gfx::mojom::AcceleratedWidgetDataView>(
        pointer, output, context_);
  }
 private:
  internal::DrmDevice_DestroyWindow_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class DrmDevice_SetWindowBounds_ParamsDataView {
 public:
  DrmDevice_SetWindowBounds_ParamsDataView() {}

  DrmDevice_SetWindowBounds_ParamsDataView(
      internal::DrmDevice_SetWindowBounds_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetWidgetDataView(
      ::gfx::mojom::AcceleratedWidgetDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadWidget(UserType* output) {
    auto* pointer = data_->widget.Get();
    return mojo::internal::Deserialize<::gfx::mojom::AcceleratedWidgetDataView>(
        pointer, output, context_);
  }
  inline void GetBoundsDataView(
      ::gfx::mojom::RectDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadBounds(UserType* output) {
    auto* pointer = data_->bounds.Get();
    return mojo::internal::Deserialize<::gfx::mojom::RectDataView>(
        pointer, output, context_);
  }
 private:
  internal::DrmDevice_SetWindowBounds_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class DrmDevice_TakeDisplayControl_ParamsDataView {
 public:
  DrmDevice_TakeDisplayControl_ParamsDataView() {}

  DrmDevice_TakeDisplayControl_ParamsDataView(
      internal::DrmDevice_TakeDisplayControl_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::DrmDevice_TakeDisplayControl_Params_Data* data_ = nullptr;
};

class DrmDevice_TakeDisplayControl_ResponseParamsDataView {
 public:
  DrmDevice_TakeDisplayControl_ResponseParamsDataView() {}

  DrmDevice_TakeDisplayControl_ResponseParamsDataView(
      internal::DrmDevice_TakeDisplayControl_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  bool success() const {
    return data_->success;
  }
 private:
  internal::DrmDevice_TakeDisplayControl_ResponseParams_Data* data_ = nullptr;
};

class DrmDevice_RelinquishDisplayControl_ParamsDataView {
 public:
  DrmDevice_RelinquishDisplayControl_ParamsDataView() {}

  DrmDevice_RelinquishDisplayControl_ParamsDataView(
      internal::DrmDevice_RelinquishDisplayControl_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::DrmDevice_RelinquishDisplayControl_Params_Data* data_ = nullptr;
};

class DrmDevice_RelinquishDisplayControl_ResponseParamsDataView {
 public:
  DrmDevice_RelinquishDisplayControl_ResponseParamsDataView() {}

  DrmDevice_RelinquishDisplayControl_ResponseParamsDataView(
      internal::DrmDevice_RelinquishDisplayControl_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  bool success() const {
    return data_->success;
  }
 private:
  internal::DrmDevice_RelinquishDisplayControl_ResponseParams_Data* data_ = nullptr;
};

class DrmDevice_RefreshNativeDisplays_ParamsDataView {
 public:
  DrmDevice_RefreshNativeDisplays_ParamsDataView() {}

  DrmDevice_RefreshNativeDisplays_ParamsDataView(
      internal::DrmDevice_RefreshNativeDisplays_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::DrmDevice_RefreshNativeDisplays_Params_Data* data_ = nullptr;
};

class DrmDevice_RefreshNativeDisplays_ResponseParamsDataView {
 public:
  DrmDevice_RefreshNativeDisplays_ResponseParamsDataView() {}

  DrmDevice_RefreshNativeDisplays_ResponseParamsDataView(
      internal::DrmDevice_RefreshNativeDisplays_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetDisplaySnapshotsDataView(
      mojo::ArrayDataView<::display::mojom::DisplaySnapshotDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadDisplaySnapshots(UserType* output) {
    auto* pointer = data_->display_snapshots.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<::display::mojom::DisplaySnapshotDataView>>(
        pointer, output, context_);
  }
 private:
  internal::DrmDevice_RefreshNativeDisplays_ResponseParams_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class DrmDevice_AddGraphicsDevice_ParamsDataView {
 public:
  DrmDevice_AddGraphicsDevice_ParamsDataView() {}

  DrmDevice_AddGraphicsDevice_ParamsDataView(
      internal::DrmDevice_AddGraphicsDevice_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetPathDataView(
      ::mojo_base::mojom::FilePathDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadPath(UserType* output) {
    auto* pointer = data_->path.Get();
    return mojo::internal::Deserialize<::mojo_base::mojom::FilePathDataView>(
        pointer, output, context_);
  }
  inline void GetFileDataView(
      ::mojo_base::mojom::FileDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadFile(UserType* output) {
    auto* pointer = data_->file.Get();
    return mojo::internal::Deserialize<::mojo_base::mojom::FileDataView>(
        pointer, output, context_);
  }
 private:
  internal::DrmDevice_AddGraphicsDevice_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class DrmDevice_RemoveGraphicsDevice_ParamsDataView {
 public:
  DrmDevice_RemoveGraphicsDevice_ParamsDataView() {}

  DrmDevice_RemoveGraphicsDevice_ParamsDataView(
      internal::DrmDevice_RemoveGraphicsDevice_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetPathDataView(
      ::mojo_base::mojom::FilePathDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadPath(UserType* output) {
    auto* pointer = data_->path.Get();
    return mojo::internal::Deserialize<::mojo_base::mojom::FilePathDataView>(
        pointer, output, context_);
  }
 private:
  internal::DrmDevice_RemoveGraphicsDevice_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class DrmDevice_DisableNativeDisplay_ParamsDataView {
 public:
  DrmDevice_DisableNativeDisplay_ParamsDataView() {}

  DrmDevice_DisableNativeDisplay_ParamsDataView(
      internal::DrmDevice_DisableNativeDisplay_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  int64_t display_id() const {
    return data_->display_id;
  }
 private:
  internal::DrmDevice_DisableNativeDisplay_Params_Data* data_ = nullptr;
};

class DrmDevice_DisableNativeDisplay_ResponseParamsDataView {
 public:
  DrmDevice_DisableNativeDisplay_ResponseParamsDataView() {}

  DrmDevice_DisableNativeDisplay_ResponseParamsDataView(
      internal::DrmDevice_DisableNativeDisplay_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  int64_t display_id() const {
    return data_->display_id;
  }
  bool success() const {
    return data_->success;
  }
 private:
  internal::DrmDevice_DisableNativeDisplay_ResponseParams_Data* data_ = nullptr;
};

class DrmDevice_ConfigureNativeDisplay_ParamsDataView {
 public:
  DrmDevice_ConfigureNativeDisplay_ParamsDataView() {}

  DrmDevice_ConfigureNativeDisplay_ParamsDataView(
      internal::DrmDevice_ConfigureNativeDisplay_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  int64_t display_id() const {
    return data_->display_id;
  }
  inline void GetDisplayModeDataView(
      ::display::mojom::DisplayModeDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadDisplayMode(UserType* output) {
    auto* pointer = data_->display_mode.Get();
    return mojo::internal::Deserialize<::display::mojom::DisplayModeDataView>(
        pointer, output, context_);
  }
  inline void GetPointDataView(
      ::gfx::mojom::PointDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadPoint(UserType* output) {
    auto* pointer = data_->point.Get();
    return mojo::internal::Deserialize<::gfx::mojom::PointDataView>(
        pointer, output, context_);
  }
 private:
  internal::DrmDevice_ConfigureNativeDisplay_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class DrmDevice_ConfigureNativeDisplay_ResponseParamsDataView {
 public:
  DrmDevice_ConfigureNativeDisplay_ResponseParamsDataView() {}

  DrmDevice_ConfigureNativeDisplay_ResponseParamsDataView(
      internal::DrmDevice_ConfigureNativeDisplay_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  int64_t display_id() const {
    return data_->display_id;
  }
  bool success() const {
    return data_->success;
  }
 private:
  internal::DrmDevice_ConfigureNativeDisplay_ResponseParams_Data* data_ = nullptr;
};

class DrmDevice_GetHDCPState_ParamsDataView {
 public:
  DrmDevice_GetHDCPState_ParamsDataView() {}

  DrmDevice_GetHDCPState_ParamsDataView(
      internal::DrmDevice_GetHDCPState_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  int64_t display_id() const {
    return data_->display_id;
  }
 private:
  internal::DrmDevice_GetHDCPState_Params_Data* data_ = nullptr;
};

class DrmDevice_GetHDCPState_ResponseParamsDataView {
 public:
  DrmDevice_GetHDCPState_ResponseParamsDataView() {}

  DrmDevice_GetHDCPState_ResponseParamsDataView(
      internal::DrmDevice_GetHDCPState_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  int64_t display_id() const {
    return data_->display_id;
  }
  bool success() const {
    return data_->success;
  }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadState(UserType* output) const {
    auto data_value = data_->state;
    return mojo::internal::Deserialize<::display::mojom::HDCPState>(
        data_value, output);
  }

  ::display::mojom::HDCPState state() const {
    return static_cast<::display::mojom::HDCPState>(data_->state);
  }
 private:
  internal::DrmDevice_GetHDCPState_ResponseParams_Data* data_ = nullptr;
};

class DrmDevice_SetHDCPState_ParamsDataView {
 public:
  DrmDevice_SetHDCPState_ParamsDataView() {}

  DrmDevice_SetHDCPState_ParamsDataView(
      internal::DrmDevice_SetHDCPState_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  int64_t display_id() const {
    return data_->display_id;
  }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadState(UserType* output) const {
    auto data_value = data_->state;
    return mojo::internal::Deserialize<::display::mojom::HDCPState>(
        data_value, output);
  }

  ::display::mojom::HDCPState state() const {
    return static_cast<::display::mojom::HDCPState>(data_->state);
  }
 private:
  internal::DrmDevice_SetHDCPState_Params_Data* data_ = nullptr;
};

class DrmDevice_SetHDCPState_ResponseParamsDataView {
 public:
  DrmDevice_SetHDCPState_ResponseParamsDataView() {}

  DrmDevice_SetHDCPState_ResponseParamsDataView(
      internal::DrmDevice_SetHDCPState_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  int64_t display_id() const {
    return data_->display_id;
  }
  bool success() const {
    return data_->success;
  }
 private:
  internal::DrmDevice_SetHDCPState_ResponseParams_Data* data_ = nullptr;
};

class DrmDevice_SetColorMatrix_ParamsDataView {
 public:
  DrmDevice_SetColorMatrix_ParamsDataView() {}

  DrmDevice_SetColorMatrix_ParamsDataView(
      internal::DrmDevice_SetColorMatrix_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  int64_t display_id() const {
    return data_->display_id;
  }
  inline void GetColorMatrixDataView(
      mojo::ArrayDataView<float>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadColorMatrix(UserType* output) {
    auto* pointer = data_->color_matrix.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<float>>(
        pointer, output, context_);
  }
 private:
  internal::DrmDevice_SetColorMatrix_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class DrmDevice_SetGammaCorrection_ParamsDataView {
 public:
  DrmDevice_SetGammaCorrection_ParamsDataView() {}

  DrmDevice_SetGammaCorrection_ParamsDataView(
      internal::DrmDevice_SetGammaCorrection_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  int64_t display_id() const {
    return data_->display_id;
  }
  inline void GetDegammaLutDataView(
      mojo::ArrayDataView<::display::mojom::GammaRampRGBEntryDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadDegammaLut(UserType* output) {
    auto* pointer = data_->degamma_lut.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<::display::mojom::GammaRampRGBEntryDataView>>(
        pointer, output, context_);
  }
  inline void GetGammaLutDataView(
      mojo::ArrayDataView<::display::mojom::GammaRampRGBEntryDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadGammaLut(UserType* output) {
    auto* pointer = data_->gamma_lut.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<::display::mojom::GammaRampRGBEntryDataView>>(
        pointer, output, context_);
  }
 private:
  internal::DrmDevice_SetGammaCorrection_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class DrmDevice_CheckOverlayCapabilities_ParamsDataView {
 public:
  DrmDevice_CheckOverlayCapabilities_ParamsDataView() {}

  DrmDevice_CheckOverlayCapabilities_ParamsDataView(
      internal::DrmDevice_CheckOverlayCapabilities_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetWidgetDataView(
      ::gfx::mojom::AcceleratedWidgetDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadWidget(UserType* output) {
    auto* pointer = data_->widget.Get();
    return mojo::internal::Deserialize<::gfx::mojom::AcceleratedWidgetDataView>(
        pointer, output, context_);
  }
  inline void GetCandidatesDataView(
      mojo::ArrayDataView<::ui::ozone::mojom::OverlaySurfaceCandidateDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadCandidates(UserType* output) {
    auto* pointer = data_->candidates.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<::ui::ozone::mojom::OverlaySurfaceCandidateDataView>>(
        pointer, output, context_);
  }
 private:
  internal::DrmDevice_CheckOverlayCapabilities_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class DrmDevice_CheckOverlayCapabilities_ResponseParamsDataView {
 public:
  DrmDevice_CheckOverlayCapabilities_ResponseParamsDataView() {}

  DrmDevice_CheckOverlayCapabilities_ResponseParamsDataView(
      internal::DrmDevice_CheckOverlayCapabilities_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  inline void GetWidgetDataView(
      ::gfx::mojom::AcceleratedWidgetDataView* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadWidget(UserType* output) {
    auto* pointer = data_->widget.Get();
    return mojo::internal::Deserialize<::gfx::mojom::AcceleratedWidgetDataView>(
        pointer, output, context_);
  }
  inline void GetCandidatesDataView(
      mojo::ArrayDataView<::ui::ozone::mojom::OverlaySurfaceCandidateDataView>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadCandidates(UserType* output) {
    auto* pointer = data_->candidates.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<::ui::ozone::mojom::OverlaySurfaceCandidateDataView>>(
        pointer, output, context_);
  }
  inline void GetStatusDataView(
      mojo::ArrayDataView<::ui::ozone::mojom::OverlayStatus>* output);

  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadStatus(UserType* output) {
    auto* pointer = data_->status.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<::ui::ozone::mojom::OverlayStatus>>(
        pointer, output, context_);
  }
 private:
  internal::DrmDevice_CheckOverlayCapabilities_ResponseParams_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};



}  // namespace mojom
}  // namespace ozone
}  // namespace ui

namespace std {

}  // namespace std

namespace mojo {

}  // namespace mojo


namespace ui {
namespace ozone {
namespace mojom {





inline void DrmDevice_CreateWindow_ParamsDataView::GetWidgetDataView(
    ::gfx::mojom::AcceleratedWidgetDataView* output) {
  auto pointer = data_->widget.Get();
  *output = ::gfx::mojom::AcceleratedWidgetDataView(pointer, context_);
}


inline void DrmDevice_DestroyWindow_ParamsDataView::GetWidgetDataView(
    ::gfx::mojom::AcceleratedWidgetDataView* output) {
  auto pointer = data_->widget.Get();
  *output = ::gfx::mojom::AcceleratedWidgetDataView(pointer, context_);
}


inline void DrmDevice_SetWindowBounds_ParamsDataView::GetWidgetDataView(
    ::gfx::mojom::AcceleratedWidgetDataView* output) {
  auto pointer = data_->widget.Get();
  *output = ::gfx::mojom::AcceleratedWidgetDataView(pointer, context_);
}
inline void DrmDevice_SetWindowBounds_ParamsDataView::GetBoundsDataView(
    ::gfx::mojom::RectDataView* output) {
  auto pointer = data_->bounds.Get();
  *output = ::gfx::mojom::RectDataView(pointer, context_);
}












inline void DrmDevice_RefreshNativeDisplays_ResponseParamsDataView::GetDisplaySnapshotsDataView(
    mojo::ArrayDataView<::display::mojom::DisplaySnapshotDataView>* output) {
  auto pointer = data_->display_snapshots.Get();
  *output = mojo::ArrayDataView<::display::mojom::DisplaySnapshotDataView>(pointer, context_);
}


inline void DrmDevice_AddGraphicsDevice_ParamsDataView::GetPathDataView(
    ::mojo_base::mojom::FilePathDataView* output) {
  auto pointer = data_->path.Get();
  *output = ::mojo_base::mojom::FilePathDataView(pointer, context_);
}
inline void DrmDevice_AddGraphicsDevice_ParamsDataView::GetFileDataView(
    ::mojo_base::mojom::FileDataView* output) {
  auto pointer = data_->file.Get();
  *output = ::mojo_base::mojom::FileDataView(pointer, context_);
}


inline void DrmDevice_RemoveGraphicsDevice_ParamsDataView::GetPathDataView(
    ::mojo_base::mojom::FilePathDataView* output) {
  auto pointer = data_->path.Get();
  *output = ::mojo_base::mojom::FilePathDataView(pointer, context_);
}






inline void DrmDevice_ConfigureNativeDisplay_ParamsDataView::GetDisplayModeDataView(
    ::display::mojom::DisplayModeDataView* output) {
  auto pointer = data_->display_mode.Get();
  *output = ::display::mojom::DisplayModeDataView(pointer, context_);
}
inline void DrmDevice_ConfigureNativeDisplay_ParamsDataView::GetPointDataView(
    ::gfx::mojom::PointDataView* output) {
  auto pointer = data_->point.Get();
  *output = ::gfx::mojom::PointDataView(pointer, context_);
}












inline void DrmDevice_SetColorMatrix_ParamsDataView::GetColorMatrixDataView(
    mojo::ArrayDataView<float>* output) {
  auto pointer = data_->color_matrix.Get();
  *output = mojo::ArrayDataView<float>(pointer, context_);
}


inline void DrmDevice_SetGammaCorrection_ParamsDataView::GetDegammaLutDataView(
    mojo::ArrayDataView<::display::mojom::GammaRampRGBEntryDataView>* output) {
  auto pointer = data_->degamma_lut.Get();
  *output = mojo::ArrayDataView<::display::mojom::GammaRampRGBEntryDataView>(pointer, context_);
}
inline void DrmDevice_SetGammaCorrection_ParamsDataView::GetGammaLutDataView(
    mojo::ArrayDataView<::display::mojom::GammaRampRGBEntryDataView>* output) {
  auto pointer = data_->gamma_lut.Get();
  *output = mojo::ArrayDataView<::display::mojom::GammaRampRGBEntryDataView>(pointer, context_);
}


inline void DrmDevice_CheckOverlayCapabilities_ParamsDataView::GetWidgetDataView(
    ::gfx::mojom::AcceleratedWidgetDataView* output) {
  auto pointer = data_->widget.Get();
  *output = ::gfx::mojom::AcceleratedWidgetDataView(pointer, context_);
}
inline void DrmDevice_CheckOverlayCapabilities_ParamsDataView::GetCandidatesDataView(
    mojo::ArrayDataView<::ui::ozone::mojom::OverlaySurfaceCandidateDataView>* output) {
  auto pointer = data_->candidates.Get();
  *output = mojo::ArrayDataView<::ui::ozone::mojom::OverlaySurfaceCandidateDataView>(pointer, context_);
}


inline void DrmDevice_CheckOverlayCapabilities_ResponseParamsDataView::GetWidgetDataView(
    ::gfx::mojom::AcceleratedWidgetDataView* output) {
  auto pointer = data_->widget.Get();
  *output = ::gfx::mojom::AcceleratedWidgetDataView(pointer, context_);
}
inline void DrmDevice_CheckOverlayCapabilities_ResponseParamsDataView::GetCandidatesDataView(
    mojo::ArrayDataView<::ui::ozone::mojom::OverlaySurfaceCandidateDataView>* output) {
  auto pointer = data_->candidates.Get();
  *output = mojo::ArrayDataView<::ui::ozone::mojom::OverlaySurfaceCandidateDataView>(pointer, context_);
}
inline void DrmDevice_CheckOverlayCapabilities_ResponseParamsDataView::GetStatusDataView(
    mojo::ArrayDataView<::ui::ozone::mojom::OverlayStatus>* output) {
  auto pointer = data_->status.Get();
  *output = mojo::ArrayDataView<::ui::ozone::mojom::OverlayStatus>(pointer, context_);
}



}  // namespace mojom
}  // namespace ozone
}  // namespace ui

#endif  // UI_OZONE_PUBLIC_INTERFACES_DRM_DEVICE_MOJOM_SHARED_H_
