// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef UI_OZONE_PUBLIC_INTERFACES_OVERLAY_SURFACE_CANDIDATE_MOJOM_SHARED_INTERNAL_H_
#define UI_OZONE_PUBLIC_INTERFACES_OVERLAY_SURFACE_CANDIDATE_MOJOM_SHARED_INTERNAL_H_

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "ui/gfx/geometry/mojo/geometry.mojom-shared-internal.h"
#include "ui/gfx/mojo/buffer_types.mojom-shared-internal.h"
#include "ui/gfx/mojo/overlay_transform.mojom-shared-internal.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/interfaces/bindings/native_struct.mojom-shared-internal.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace ui {
namespace ozone {
namespace mojom {
namespace internal {
class OverlaySurfaceCandidate_Data;

struct OverlayStatus_Data {
 public:
  static bool constexpr kIsExtensible = false;

  static bool IsKnownValue(int32_t value) {
    switch (value) {
      case 0:
      case 1:
      case 2:
        return true;
    }
    return false;
  }

  static bool Validate(int32_t value,
                       mojo::internal::ValidationContext* validation_context) {
    if (kIsExtensible || IsKnownValue(value))
      return true;

    ReportValidationError(validation_context,
                          mojo::internal::VALIDATION_ERROR_UNKNOWN_ENUM_VALUE);
    return false;
  }
};

#pragma pack(push, 1)
class  OverlaySurfaceCandidate_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(OverlaySurfaceCandidate_Data));
      new (data()) OverlaySurfaceCandidate_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    OverlaySurfaceCandidate_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<OverlaySurfaceCandidate_Data>(index_);
    }
    OverlaySurfaceCandidate_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t transform;
  int32_t format;
  mojo::internal::Pointer<::gfx::mojom::internal::Size_Data> buffer_size;
  mojo::internal::Pointer<::gfx::mojom::internal::RectF_Data> display_rect;
  mojo::internal::Pointer<::gfx::mojom::internal::RectF_Data> crop_rect;
  mojo::internal::Pointer<::gfx::mojom::internal::Rect_Data> clip_rect;
  uint8_t is_clipped : 1;
  uint8_t overlay_handled : 1;
  uint8_t pad7_[3];
  int32_t plane_z_order;

 private:
  OverlaySurfaceCandidate_Data();
  ~OverlaySurfaceCandidate_Data() = delete;
};
static_assert(sizeof(OverlaySurfaceCandidate_Data) == 56,
              "Bad sizeof(OverlaySurfaceCandidate_Data)");
// Used by OverlaySurfaceCandidate::WrapAsMessage to lazily serialize the struct.
template <typename UserType, typename DataView>
struct OverlaySurfaceCandidate_UnserializedMessageContext
    : public mojo::internal::UnserializedMessageContext {
 public:
  static const mojo::internal::UnserializedMessageContext::Tag kMessageTag;

  OverlaySurfaceCandidate_UnserializedMessageContext(
    uint32_t message_name,
    uint32_t message_flags,
    UserType input)
      : mojo::internal::UnserializedMessageContext(&kMessageTag, message_name, message_flags)
      , user_data_(std::move(input)) {}
  ~OverlaySurfaceCandidate_UnserializedMessageContext() override = default;

  UserType TakeData() {
    return std::move(user_data_);
  }

 private:
  // mojo::internal::UnserializedMessageContext:
  void Serialize(mojo::internal::SerializationContext* context,
                 mojo::internal::Buffer* buffer) override {
    OverlaySurfaceCandidate_Data::BufferWriter writer;
    mojo::internal::Serialize<DataView>(user_data_, buffer, &writer, context);
  }

  UserType user_data_;
};

template <typename UserType, typename DataView>
const mojo::internal::UnserializedMessageContext::Tag
    OverlaySurfaceCandidate_UnserializedMessageContext<UserType, DataView>::kMessageTag = {};

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace ozone
}  // namespace ui

#endif  // UI_OZONE_PUBLIC_INTERFACES_OVERLAY_SURFACE_CANDIDATE_MOJOM_SHARED_INTERNAL_H_